#COMPILE EXE                                                                
'#DEBUG DISPLAY ON                                            
#DIM ALL                                     
#INCLUDE "win32api.inc"
#INCLUDE "FE2D.inc"
'#INCLUDE "debug.inc"
#RESOURCE "fe2d.pbr" 'for icon in explorer

$verNo = "1.40"

FUNCTION PBMAIN
   LOCAL ti AS STRING
   LOCAL hMutex, nStyle AS LONG
   LOCAL prgName, windowName AS ASCIIZ * 32

   ti = "2D Finite Element Program"
   '------- check if instance of winPam already running...
   windowName = ti
   PrgName = "FE2D by chasDietz"
   hMutex = CreateMutex(BYVAL %Null, BYVAL %Null, BYVAL VARPTR(PrgName))
   IF hMutex THEN
      IF GetLastError = %ERROR_ALREADY_EXISTS THEN
         'instance of winPam already running
         hDlg = FindWindow(BYVAL %NULL, BYVAL VARPTR(windowName))
         ShowWindow hDlg, %SW_RESTORE
         SetForegroundWindow hDlg
         CloseHandle hMutex: EXIT FUNCTION
      END IF
   END IF
   nStyle = %WS_SYSMENU OR %WS_MINIMIZEBOX OR %WS_THICKFRAME
   DIALOG NEW 0, ti, , , 270, 280, nStyle TO hDlg
   addMenu
   addToolBar
   CONTROL ADD STATUSBAR, hDlg, %ID_Status, "", 0, 0, 0, 0, %SBARS_SIZEGRIP
   nStyle = %WS_VSCROLL OR %ES_MULTILINE OR %ES_WANTRETURN OR %ES_NOHIDESEL or %WS_TABSTOP
   CONTROL ADD TEXTBOX, hDlg, %ID_TextBox,"", 10, 30, 250, 250, nStyle, %WS_EX_CLIENTEDGE
   DIALOG SHOW MODELESS hDlg CALL dlgProc
   DO
      DIALOG DOEVENTS 0
   LOOP WHILE ISWIN(hDlg)
   CloseHandle hMutex
END FUNCTION

CALLBACK FUNCTION dlgProc()
   LOCAL flags AS DWORD
   LOCAL n, hIcon, hInst, hFont, w1, w2 AS LONG
   LOCAL dlgWidth, dlgHeight AS LONG
   LOCAL s, f, ff, fPath, filter AS STRING
   LOCAL pd AS PRINTDLGAPI

   SELECT CASE CBMSG
   CASE %WM_INITDIALOG
      'show application icon
      hInst = GetModuleHandle(BYVAL %NULL)
      hIcon = LoadImage(hInst, "fe2d", %IMAGE_ICON, 0, 0, %LR_DEFAULTSIZE)
      DIALOG SEND hDlg, %WM_SETICON, 0, hIcon
      'subclass textbox for capturing keyup and left mouse button
      CONTROL HANDLE hDlg, %ID_TextBox TO hTB
      gOrigTBProc = SetWindowLong (hTB, %GWL_WNDPROC, CODEPTR(newTBProc&))
      FONT NEW "Courier New", 9 TO hFont
      control set font cb.hndl, %ID_Textbox, hFont
      s = "Try this"
      di.cbSize = SIZEOF(di)
      di.lpszDocName = VARPTR(s)
      di.fwType = 0
      dataFolder = CURDIR$ + "\"
      IF LEN(DIR$("*.FE2")) = 0 THEN
         'dataFolder = specialFolder(%CSIDL_COMMON_DOCUMENTS)
         dataFolder = specialFolder(%CSIDL_COMMON_APPDATA)
         IF LEN(dataFolder) = 0 THEN dataFolder = "C:\My Documents\"
         dataFolder = dataFolder + "\cgdSoftware\FE2D\"
         IF ISFOLDER(dataFolder) = 0 THEN createFolder dataFolder
      END IF
      rad = .017453292519943
      thisFile = REMOVE$(COMMAND$, """")
      IF LEN(thisFile) THEN
         openTheFile 'FE2 file association
         SetFocus hTB
      END IF
   CASE %WM_SIZE
      DIALOG GET CLIENT CB.HNDL TO dlgWidth, dlgHeight
      CONTROL SET SIZE hDlg, %ID_Toolbar, dlgWidth, 22
      w1 = dlgWidth - 20: w2 = dlgHeight - 50
      CONTROL SET SIZE CB.HNDL, %ID_Textbox, w1, w2
      w1 = .60 * dlgWidth: w2 = .20 * dlgWidth
      STATUSBAR SET PARTS hDlg, %ID_Status, w1, w2, 9999
      showStatus 1, ""
      showStatus 3, ""
   CASE %WM_COMMAND
      'toolbar selections ------------------------------------------------
      IF CBCTL = %ID_OpenTB THEN
         DIALOG SEND CBHNDL, %WM_COMMAND, %ID_Open, 0
      ELSEIF CBCTL = %ID_SaveTB THEN
         DIALOG SEND CBHNDL, %WM_COMMAND, %ID_Save, 0
      ELSEIF CBCTL = %ID_PrintTB THEN
         DIALOG SEND CBHNDL, %WM_COMMAND, %ID_Print, 0
      ELSEIF CBCTL = %ID_RunTB THEN
         DIALOG SEND CBHNDL, %WM_COMMAND, %ID_Run, 0
      ELSEIF CBCTL = %ID_SolnTB THEN
         DIALOG SEND CBHNDL, %WM_COMMAND, %ID_Disp, 0
      ELSEIF CBCTL = %ID_PlotTB THEN
         DIALOG SEND CBHNDL, %WM_COMMAND, %ID_PlotDefm, 0
      ELSEIF CBCTL = %ID_QuitTB THEN
         DIALOG END hDispDlg
         DIALOG END hPlotDlg
         DIALOG SEND CBHNDL, %WM_COMMAND, %ID_Exit, 0
      END IF
      CONTROL SEND hDlg, CBCTL, %BM_SETSTYLE, %BS_PUSHBUTTON, %TRUE
      'menu selections ---------------------------------------------------
      IF CBCTL = %ID_NEW THEN
         IF LEN(thisFile) THEN
            IF fileChanged THEN
               quitProgram: IF doNotQuit THEN EXIT FUNCTION
            END IF
            thisFile = ""
         END IF
         fileChanged = 0: runPhase = 0
         CONTROL SET TEXT hDlg, %ID_TextBox, ""
         MENU SET STATE hSolveMenu, 1, %MF_GRAYED
         MENU SET STATE hSolveMenu, 2, %MF_GRAYED
         MENU SET STATE hSolveMenu, 3, %MF_GRAYED
         MENU SET STATE hSolveMenu, 4, %MF_GRAYED
         CONTROL DISABLE CBHNDL, %ID_RunTB
         CONTROL DISABLE CBHNDL, %ID_SolnTB
         CONTROL DISABLE CBHNDL, %ID_PlotTB
      ELSEIF CBCTL = %ID_Open THEN
         fPath = dataFolder: f = ""
         filter = CHR$("FE Files (*.fe2)", 0, "*.fe2", 0, _
                       "All Files (*.*)", 0, "*.*", 0)
         flags = %OFN_FILEMUSTEXIST OR %OFN_HIDEREADONLY OR _
                 %OFN_LONGNAMES OR %OFN_EXPLORER OR %OFN_ENABLESIZING
         display openfile cb.hndl,,, "Open File", fPath, filter, "", "fe2", flags to f
         if len(f) then
            IF fileChanged THEN
               s = "File has changed..." + $CRLF + "Should it be saved?"
               n = MSGBOX(s, %MB_YESNO + %MB_ICONQUESTION, "Save File")
               IF n = %IDYES THEN saveTheFile
            END IF
            thisFile = f
            openTheFile
            SetFocus hTB
         END IF
         control set focus cb.hndl, %ID_Textbox
      ELSEIF CBCTL = %ID_Save THEN
         IF LEN(thisFile) THEN
            n = MSGBOX("Save file now?", %MB_YESNO + %MB_ICONQUESTION, "Save File")
            IF n = %IDYES THEN fileChanged = 1: saveTheFile
         ELSE
            DIALOG SEND hDlg, %WM_COMMAND, %ID_SaveAs, 0
         END IF
         control set focus cb.hndl, %ID_Textbox
      ELSEIF CBCTL = %ID_SaveAs THEN
         fPath = dataFolder: ff = thisFile
         filter = CHR$("FE Files (*.fe2)", 0, "*.fe2", 0, _
                       "All Files (*.*)", 0, "*.*", 0)
         flags = %OFN_OVERWRITEPROMPT OR %OFN_HIDEREADONLY OR %OFN_LONGNAMES or %OFN_ENABLESIZING
         display savefile cb.hndl,,, "Save File", fPath, filter, ff, "fe2", flags to f 
         if len(f) then
            thisFile = f: fileChanged = 1
            saveTheFile
            showStatus 1, ""
            MENU SET STATE hSolveMenu, 2, %MF_ENABLED
            CONTROL ENABLE CBHNDL, %ID_RunTB
         END IF
      ELSEIF CBCTL = %ID_Print THEN 'print file
         printModel
         control set focus cb.hndl, %ID_Textbox
      elseif cbctl = %ID_Plot then
         plotModel
      ELSEIF CBCTL = %ID_Exit THEN 'exit program
         quitProgram
         IF doNotQuit THEN EXIT FUNCTION
         DIALOG END hDlg
      ELSEIF CBCTL = %ID_Reset THEN 'reset program
         runPhase = 0: kStorData = 1 
         control disable hDlg, %ID_SolnTB
         control disable hDlg, %ID_PlotTB
         MENU SET STATE hSolveMenu, 1, %MF_GRAYED
      ELSEIF CBCTL = %ID_Run THEN 'run file
         modelDlg
      ELSEIF CBCTL = %ID_Disp THEN 'display solution results
         displayResults
      ELSEIF CBCTL = %ID_PlotDefm THEN 'plot model + deformation
         plotModel
      ELSEIF CBCTL = %ID_Help THEN
         winHelp CBHNDL, dataFolder + $helpFile, 15, 0
      ELSEIF CBCTL = %ID_Syntax THEN
         winHelp CBHNDL, dataFolder + $syntaxFile, 15, 0
      ELSEIF CBCTL = %ID_About THEN
         showAbout
      'textbox ------------------------------------------------------------
      ELSEIF CBCTL = %ID_TextBox THEN
         IF CBCTLMSG = %EN_CHANGE THEN
            fileChanged = 1: kStorData = 1
            CONTROL SEND hDlg, %ID_TextBox, %EM_LINEFROMCHAR, -1, 0 TO n
            INCR n
            IF n <= lineEndModel THEN
               runPhase = 0
            ELSE
               IF runPhase >= 2 THEN runPhase = 2
            END IF
            MENU SET STATE hSolveMenu, 3, %MF_GRAYED
            MENU SET STATE hSolveMenu, 4, %MF_GRAYED
            CONTROL DISABLE CBHNDL, %ID_SolnTB
            CONTROL DISABLE CBHNDL, %ID_PlotTB
         ELSEIF CBCTLMSG = %EN_SETFOCUS THEN
            CONTROL SEND CBHNDL, CBCTL, %EM_SETSEL, 0, 0
            CONTROL SEND CBHNDL, CBCTL, %EM_SCROLLCARET, 0, 0
            lineCursor = 1: showStatus 3, ""
            IF runPhase > 2 THEN
               'runPhase = 2
               MENU SET STATE hSolveMenu, 3, %MF_ENABLED
               MENU SET STATE hSolveMenu, 4, %MF_ENABLED
               CONTROL ENABLE CBHNDL, %ID_SolnTB
               CONTROL ENABLE CBHNDL, %ID_PlotTB
            END IF
         END IF
      END IF
   CASE %WM_SYSCOMMAND
      IF CBCTL=%SC_CLOSE THEN
         quitProgram
         IF doNotQuit THEN FUNCTION = 1: EXIT FUNCTION
      END IF
   CASE %WM_DESTROY
      winHelp hDlg, $helpFile, %HELP_QUIT, 0
      winHelp hDlg, $syntaxFile, %HELP_QUIT, 0
   END SELECT
END FUNCTION

FUNCTION newTBProc&(BYVAL h&, BYVAL wMsg&, BYVAL wParm&, BYVAL lParm&)
   'capture line position of key and left mouse button
   LOCAL n AS LONG
   SELECT CASE wMsg&
   CASE %WM_KEYUP, %WM_LBUTTONUP
      CONTROL SEND hDlg, %ID_TextBox, %EM_LINEFROMCHAR, -1, 0 TO n
      lineCursor = n + 1: showStatus 3, ""
   END SELECT
   FUNCTION = callWindowProc(gOrigTBProc, h&, wMsg&, wParm&, lParm&)
END FUNCTION

SUB addMenu
   MENU NEW BAR TO hMenu
   MENU NEW POPUP TO hFileMenu '-----------------------------------
   MENU ADD STRING, hFileMenu, "&New", %ID_New, %MF_ENABLED
   MENU ADD STRING, hFileMenu, "&Open", %ID_Open, %MF_ENABLED
   MENU ADD STRING, hFileMenu, "&Save", %ID_Save, %MF_ENABLED
   MENU ADD STRING, hFileMenu, "Save&As", %ID_SaveAs, %MF_ENABLED
   MENU ADD STRING, hFileMenu, "-", 0, 0
   MENU ADD STRING, hFileMenu, "P&rint Model", %ID_Print, %MF_ENABLED
   menu add string, hFileMenu, "Plot Model", %ID_Plot, %MF_ENABLED
   MENU ADD STRING, hFileMenu, "E&xit", %ID_Exit, %MF_ENABLED
   MENU ADD POPUP, hMenu, "&File", hFileMenu, %MF_ENABLED
   MENU NEW POPUP TO hSolveMenu '-----------------------------------
   MENU ADD STRING, hSolveMenu, "&Reset Solution", %ID_Reset, %MF_GRAYED
   MENU ADD STRING, hSolveMenu, "R&un Solution", %ID_Run, %MF_GRAYED
   MENU ADD STRING, hSolveMenu, "&Show Solution", %ID_Disp, %MF_GRAYED
   MENU ADD STRING, hSolveMenu, "P&lot Deformation", %ID_PlotDefm, %MF_GRAYED
   MENU ADD POPUP, hMenu, "&Solve", hSolveMenu, %MF_ENABLED
   MENU NEW POPUP TO hHelpMenu '-----------------------------------
   MENU ADD STRING, hHelpMenu, "&Help", %ID_Help, %MF_ENABLED
   MENU ADD STRING, hHelpMenu, "&Syntax", %ID_Syntax, %MF_ENABLED
   MENU ADD STRING, hHelpMenu, "&About", %ID_About, %MF_ENABLED
   MENU ADD POPUP, hMenu, "&Help", hHelpMenu, %MF_ENABLED
   MENU ATTACH hMenu, hDlg
END SUB

SUB addToolbar()
   LOCAL nStyle, w, h AS LONG
   nStyle = %SS_GRAYRECT + %SS_BLACKFRAME
   DIALOG GET CLIENT hDlg TO w, h
   CONTROL ADD LINE, hDlg, %ID_Toolbar, "", 0, 0, w - 4, 22, nStyle, %WS_EX_CLIENTEDGE
   nStyle = %BS_CENTER
   CONTROL ADD BUTTON, hDlg, %ID_OpenTB, "Open", 2, 2, 30, 18, nStyle
   CONTROL ADD BUTTON, hDlg, %ID_SaveTB, "Save", 32, 2, 30, 18, nStyle
   CONTROL ADD BUTTON, hDlg, %ID_PrintTB, "Print", 62, 2, 30, 18, nStyle
   CONTROL ADD BUTTON, hDlg, %ID_RunTB, "Run", 97, 2, 30, 18, nStyle OR %WS_DISABLED
   CONTROL ADD BUTTON, hDlg, %ID_SolnTB, "Soln", 127, 2, 30, 18, nStyle OR %WS_DISABLED
   CONTROL ADD BUTTON, hDlg, %ID_PlotTB, "Plot", 157, 2, 30, 18, nStyle OR %WS_DISABLED
   CONTROL ADD BUTTON, hDlg, %ID_QuitTB, "Quit", 192, 2, 30, 18, nStyle
END SUB

SUB showStatus(panelNo AS LONG, s AS STRING)
   LOCAL n AS LONG, thisFileDir AS STRING
   IF panelNo = 1 THEN
      IF LEN(s) = 0 THEN
         n = INSTR(-1, thisFile, "\")
         thisFileDir = LEFT$(thisFile, n - 1)
         nameOfFile = MID$(thisFile, n + 1)
         IF thisFileDir = dataFolder THEN
            s = nameOfFile
         ELSE
            s = thisFile
         END IF
      END IF
   ELSEIF panelNo = 3 THEN
      CONTROL SEND hDlg, %ID_TextBox, %EM_GETLINECOUNT, 0, 0 TO n
      IF n > 1 THEN s = STR$(lineCursor) + " of " + STR$(n)
   END IF
   'SendMessage hStatus, %SB_SETTEXT, panelNo - 1, BYVAL STRPTR(s)
   STATUSBAR SET TEXT hDlg, %ID_Status, panelNo, 0, s
END SUB

SUB openTheFile
   LOCAL fileNum AS LONG
   LOCAL s AS STRING, TXT AS STRING
   fileNum = FREEFILE
   s = DIR$(thisFile) 'check if file exists
   IF LEN(s) = 0 THEN thisFile = "": EXIT SUB
   OPEN thisFile FOR INPUT AS fileNum
   TXT = "": runPhase = 0
   WHILE NOT EOF(fileNum)
      LINE INPUT #fileNum, s
      TXT = TXT + s + $CRLF
   WEND
   CLOSE #fileNum
   TXT = LEFT$(TXT, LEN(TXT) - 2)
   CONTROL SET TEXT hDlg, %ID_TextBox, TXT
   numLines = PARSECOUNT(TXT, $CRLF)
   fileChanged = 0: kStorData = 1
   runPhase = 0  :showStatus 1, ""
   MENU SET STATE hSolveMenu, 2, %MF_ENABLED
   MENU SET STATE hSolveMenu, 3, %MF_GRAYED
   MENU SET STATE hSolveMenu, 4, %MF_GRAYED
   CONTROL ENABLE hDlg, %ID_RunTB
   CONTROL DISABLE hDlg, %ID_SolnTB
   CONTROL DISABLE hDlg, %ID_PlotTB
   showStatus 3, ""
END SUB

SUB saveTheFile
   LOCAL fileNum AS LONG, TXT AS STRING
   fileNum = FREEFILE
   OPEN thisFile FOR OUTPUT AS fileNum
   CONTROL GET TEXT hDlg, %ID_TextBox TO TXT
   PRINT #fileNum, TXT
   CLOSE #fileNum
   fileChanged = 0
END SUB

SUB quitProgram()
   LOCAL n AS LONG
   doNotQuit = 0
   IF fileChanged THEN
      n = MSGBOX("File records have changed..." & $CRLF _
      & "do you want to save them?", %MB_YESNOCANCEL + %MB_ICONQUESTION, "Save File")
      IF n = %IDCANCEL THEN
         doNotQuit = 1: EXIT SUB
      ELSEIF n = %IDYES THEN
         IF LEN(thisFile) THEN
            saveTheFile
         ELSE
            DIALOG SEND hDlg, %WM_COMMAND, %ID_SaveAs, 0
         END IF
      END IF
   END IF
END SUB

SUB modelDlg
   LOCAL nStyle AS LONG, wi AS LONG, ht AS LONG, ti AS STRING
   LOCAL listX AS LONG, listY AS LONG, listW AS LONG, listH AS LONG
   wi = 240: ht = 205: listX = 5: listY = 10
   listW = wi - 2 * listX: listH = ht - 7 * listY
   ti = "Summary of Model Processing"
   DIALOG NEW hDlg, ti, 10, 10, wi, ht, %WS_SYSMENU TO hModelDlg
   nStyle = %WS_VSCROLL OR %ES_MULTILINE OR %ES_READONLY OR %WS_TABSTOP
   CONTROL ADD TEXTBOX, hModelDlg, %ID_Output, "", listX, listY, listW, listH, nStyle, %WS_EX_CLIENTEDGE
   nStyle = %BS_DEFAULT + %WS_TABSTOP
   CONTROL ADD BUTTON, hModelDlg, %IDOK, "C&ontinue", 50, 150, 60, 30, nStyle
   CONTROL ADD BUTTON, hModelDlg, %IDCANCEL, "&Cancel", 120, 150, 60, 30, nStyle
   DIALOG SHOW MODeless hModelDlg CALL modelProc
END SUB

CALLBACK FUNCTION modelProc()
   LOCAL sTxt AS ASCIIZ*32
   SELECT CASE CBMSG
   CASE %WM_INITDIALOG
      CONTROL SEND CBHNDL, %IDOK, %BM_SETSTYLE, %BS_DEFPUSHBUTTON, %TRUE
      IF kStorData THEN storModelData
      IF runPhase = 0 THEN
         sTxt = "Processing Model Data"
         SetWindowText hModelDlg, sTxt
         initialize
         IF LEN(sErr) THEN EXIT FUNCTION
         processModel
         MENU SET STATE hSolveMenu, 1, %MF_ENABLED
         MENU SET STATE hSolveMenu, 4, %MF_ENABLED
         CONTROL ENABLE hDlg, %ID_PlotTB
      ELSEIF runPhase = 1 THEN
         sTxt = "Performing Decomposition"
         SetWindowText hModelDlg, sTxt
         stiff
         IF kRot THEN trfm 
         Dcomp
      ELSEIF runPhase >= 2 THEN 
         sTxt = "Running Load Cases"
         SetWindowText hModelDlg, sTxt
         'DIALOG SHOW STATE hModelDlg, %SW_HIDE
         IF nSubcases THEN subCaseDlg
         'DIALOG SHOW STATE hModelDlg, %SW_RESTORE
         loads
         rhsol
         stress
      ELSE
         DIALOG END CBHNDL
      END IF
      CONTROL SET FOCUS CBHNDL, %IDOK
   CASE %WM_COMMAND
      IF CBCTL = %ID_Output AND CBCTLMSG = %EN_SETFOCUS THEN
         CONTROL SEND CBHNDL, CBCTL, %EM_SETSEL, 0, 0
         CONTROL SEND CBHNDL, CBCTL, %EM_SCROLLCARET, 0, 0
      ELSEIF CBCTL = %IDOK THEN
         IF runPhase = 1 THEN 
            sTxt = "Perform Decomposition"
            SetWindowText hModelDlg, sTxt
            stiff
            IF kRot THEN trfm
            Dcomp
         ELSEIF runPhase = 2 THEN 
            sTxt = "Running Load Cases"
            SetWindowText hModelDlg, sTxt
            IF nSubcases THEN subCaseDlg
            loads
            rhsol
            stress
         ELSE
            DIALOG END CBHNDL
         END IF
         DIALOG SEND hDlg, %WM_COMMAND, %ID_Textbox, 0
      ELSEIF CBCTL = %IDCANCEL THEN
         DIALOG END CBHNDL
      END IF
      CONTROL SET FOCUS hDlg, %ID_TextBox
   END SELECT
END FUNCTION

SUB storModelData
   LOCAL i AS LONG, s AS STRING, TXT AS STRING
   kStorData = 0
   CONTROL GET TEXT hDlg, %ID_TextBox TO TXT
   numLines = PARSECOUNT(TXT, $CRLF)
   REDIM modelData(numLines)
   nSubcases = 0
   FOR i = 1 TO numLines 'scan data for dimensions
      s = TRIM$(PARSE$(TXT, $CRLF, i))
      modelData(i) = s
      IF LEFT$(UCASE$(s), 7) = "SUBCASE" THEN INCR nSubcases
   NEXT i
   IF nSubcases > 10 THEN errMsg 22, 10, 0
END SUB

SUB initialize
   'determine number of grids, beams, quads for array dimensions
   'check minimum requirements of model
   '-----------------------------------------------------------------
   LOCAL i AS LONG, j AS LONG, nRacts AS LONG, nEndModel AS LONG
   LOCAL keyWord AS STRING, s AS STRING, m AS LONG, n AS LONG
   DIM F(10) AS DOUBLE, A(2) AS STRING
   nGrids = 0: nBeams = 0: nQuads = 0
   nProps = 0: nMatls = 0: nPolars = 0
   sErr = "": sModel = "": sSolve = ""
   kRot = 0:  numGrids = 0: numBeams = 0: numQuads = 0
   FOR i = 1 TO numLines 'scan data for dimensions
      s = PARSE$(modelData(i), $Comment, 1)
      IF LEN(s) = 0 THEN ITERATE
      m = 10: n = 2
      readFF s, m, n, F(), A()
      IF n < 0 THEN errMsg 8, 0, i
      keyWord = UCASE$(A(1))
      IF keyWord = "POLAR" THEN
         j = F(1): nPolars = MAX(nPolars, j, 1)
      ELSEIF keyWord = "GRID" THEN
         INCR numGrids
         j = F(1): nGrids = MAX(nGrids, j)
      ELSEIF keyWord = "BEAM" THEN
         INCR numBeams
         j = F(1): nBeams = MAX(nBeams, j)
      ELSEIF keyWord = "QUAD" THEN
         INCR numQuads
         j = F(1): nQuads = MAX(nQuads, j)
      ELSEIF keyWord = "PROP" THEN
         j = F(1): nProps = MAX(nProps, j, 1)
      ELSEIF keyWord = "MATL" THEN
         j = F(1): nMatls = MAX(nMatls, j, 1)
      ELSEIF keyWord = "SPRG" THEN
         INCR nSprgs
      ELSEIF keyWord = "RACT" THEN
         INCR nRacts
      ELSEIF keyWord = "ENDMODEL" THEN
         nEndModel = 1
      END IF
   NEXT i
   IF nGrids = 0 THEN errMsg 23, 0, 0
   IF nBeams + nQuads + nSprgs = 0 THEN errMsg 24, 0, 0
   IF nBeams + nQuads AND nProps = 0 THEN errMsg 25, 0, 0
   IF nBeams + nQuads AND nMatls = 0 THEN errMsg 26, 0, 0
   IF nRacts + nSprgs = 0 THEN errMsg 27, 0, 0
   IF nEndModel = 0 THEN errMsg 28, 0, 0
   IF LEN(sErr) THEN
      sModel = sErr + $CRLF + "Fatal error... Done processing model"
      CONTROL SET TEXT hModelDlg, %ID_Output, sModel
      CONTROL DISABLE hModelDlg, %IDOK
      EXIT SUB
   END IF
   REDIM CBM(numBeams,13) AS DOUBLE
   REDIM CQD(numQuads,43) AS DOUBLE
   REDIM CORD(numGrids,6) AS DOUBLE
   REDIM NBM(numBeams,3) AS LONG
   REDIM NQD(numQuads,4) AS LONG
   REDIM DOF(numGrids,4) AS LONG
   REDIM XGR(nGrids) AS LONG
   REDIM XBM(nBeams) AS LONG
   REDIM XQD(nQuads) AS LONG
   REDIM FLC(10) AS DOUBLE
   FLC(0) = 1
   IF nQuads THEN
      REDIM XII(4), ETA(4), GAUSS(2), B(3,8), D(4)
      XII(1) = -1: XII(2) = 1: XII(3) = 1: XII(4) = -1
      ETA(1) = -1: ETA(2) = -1: ETA(3) = 1: ETA(4) = 1
      GAUSS(1) = -.57735: GAUSS(2) = .57735
   END IF
   eTol = 1.D-12
END SUB

SUB readFF(s AS STRING, m AS LONG, n AS LONG, F() AS DOUBLE, A() AS STRING)
   'read free form record data
   'numeric data goes in F() and alphabetic text into A()
   '---------------------------------------------------------------------
   LOCAL delimiters AS STRING, ITEM AS STRING, t AS STRING, i AS LONG
   LOCAL mm AS LONG, nn AS LONG
   REDIM F(m) AS DOUBLE, A(n) AS STRING
   mm = m: nn = n
   m = 0: n = 0: t = s: delimiters = " ,"
   DO
      i = INSTR(t, ANY delimiters)
      IF i THEN
         ITEM = TRIM$(LEFT$(t, i - 1))
         t = LTRIM$(MID$(t, i + 1))
      ELSE
         ITEM = t
      END IF
      IF ITEM >= CHR$(65) THEN 'alpha item
         INCR n: IF n <= nn THEN A(n) = ITEM ELSE n = -1: EXIT SUB
      ELSEIF ITEM >= CHR$(45) THEN 'numerical item
         INCR m: IF m <= mm THEN F(m) = VAL(ITEM) ELSE n = -1: EXIT SUB
      END IF
   LOOP WHILE i
END SUB

SUB processModel
   'read model data
   LOCAL i AS LONG, j AS LONG, k AS LONG, m AS LONG, n AS LONG
   LOCAL keyWord AS STRING, subKey AS STRING, s AS STRING
   LOCAL x0 AS DOUBLE, y0 AS DOUBLE, x AS DOUBLE, y AS DOUBLE
   LOCAL u AS DOUBLE, r AS DOUBLE, a AS DOUBLE, v AS DOUBLE
   LOCAL b AS DOUBLE, ecc AS DOUBLE, Pcol AS DOUBLE, G AS DOUBLE
   LOCAL E AS DOUBLE, rr2 AS DOUBLE, d AS DOUBLE, alfa AS DOUBLE
   LOCAL uu AS DOUBLE, u2 AS DOUBLE, u3 AS DOUBLE, u4 AS DOUBLE
   LOCAL nProp AS LONG, nMatl AS LONG, nType AS LONG
   LOCAL r1 AS DOUBLE, r2 AS DOUBLE, r3 AS DOUBLE, r4 AS DOUBLE
   LOCAL n1 AS LONG, n2 AS LONG, n3 AS LONG, n4 AS LONG
   LOCAL lineDOFS AS LONG, numDOFS AS LONG
   LOCAL kOrder AS BYTE, kOrder1 AS BYTE, kOrder2 AS BYTE
   LOCAL iMin AS LONG, iMax AS LONG, nnr AS LONG
   LOCAL nGridSeq AS LONG, kConstraint AS BYTE
   DIM F(20) AS DOUBLE, A(2) AS STRING, DOFS(3) AS LONG
   DIM PDAT(nProps,4) AS DOUBLE, EDAT(nMatls,4) AS DOUBLE
   DIM NGRD(numGrids) AS LONG, NSEQ(numGrids) AS LONG

   '------- read in grids and elements
   numGrids = 0: numBeams = 0: numQuads = 0
   DO
      INCR j
      showStatus 2, "Process"+STR$(j)
      s = PARSE$(modelData(j), $Comment, 1)
      IF LEN(s) = 0 THEN ITERATE
      m = 20: n = 2
      readFF s, m, n, F(), A()
      IF n < 1 THEN errMsg 8, 0, j
      keyWord = UCASE$(A(1))
      subKey = UCASE$(A(2))
      i = F(1)
      SELECT CASE keyWord
      CASE "GRID"
         'GRID'  N  X  Y  A
         'GRID'  N  R  Th 'POLAR'  NP  A
         'GRID'  N  'EQ' M
         INCR numGrids
         XGR(i) = numGrids
         NGRD(numGrids) = j
         IF (m < 2) THEN errMsg 8, i, j
         CORD(numGrids,1) = F(2)
         CORD(numGrids,2) = F(3)
         DOF(numGrids,4) = 0
         NGRD(numGrids) = j
         IF subKey = "POLAR" THEN
            DOF(numGrids,4) = -1
            NSEQ(numGrids) = F(4) + 1000000
            CORD(numGrids,3) = F(3) * RAD
            IF (m = 5) THEN CORD(numGrids,3) = F(5) * RAD
         ELSEIF subKey = "EQ" THEN
            NSEQ(numGrids) = -F(2)
         ELSE
            CORD(numGrids,3) = F(4) * RAD
         END IF
         kOrder = 1
      CASE "BEAM"
         'BEAM'  N  N1  N2  Prop  Matl  ecc1  ecc2  type
         'BEAM'  N  N1  N2  Prop  Matl  'PIN'
         'BEAM'  N  N1  N2  'PIN'
         INCR numBeams
         XBM(i) = numBeams
         IF (m < 3) THEN errMsg 8, i, j
         IF F(2) = F(3) THEN errMsg 7, i, j
         IF subKey = "PIN"  THEN NBM(numBeams, 3) = 1
         IF subKey = "BEND" THEN NBM(numBeams, 3) = 2
         IF subKey = "CURV" THEN NBM(numBeams, 3) = 3
         NBM(numBeams,0) = i
         NBM(numBeams,1) = F(2)
         NBM(numBeams,2) = F(3)
         CBM(numBeams,1) = F(4)
         CBM(numBeams,2) = F(5)
         CBM(numBeams,10) = F(6)
         CBM(numBeams,11) = F(7)
         n = max(F(2), F(3))
         if n > numGrids then errMsg 9, n, i
         kOrder = 1
      CASE "QUAD"
         'QUAD'  N  N1  N2  N3  N4  Prop  Matl
         INCR numQuads
         XQD(i) = numQuads
         IF (m < 4) THEN errMsg 8, i, j
         IF F(2) = F(3) THEN errMsg 7, i, j
         IF F(2) = F(4) THEN errMsg 7, i, j
         IF F(2) = F(5) THEN errMsg 7, i, j
         IF F(3) = F(4) THEN errMsg 7, i, j
         IF F(3) = F(5) THEN errMsg 7, i, j
         IF F(4) = F(5) THEN errMsg 7, i, j
         NQD(numQuads,0) = i
         NQD(numQuads,1) = F(2)
         NQD(numQuads,2) = F(3)
         NQD(numQuads,3) = F(4)
         NQD(numQuads,4) = F(5)
         IF NQD(numQuads,4) = 0 THEN NQD(numQuads,4) = NQD(numQuads,3)
         CQD(numQuads,1) = F(6)
         CQD(numQuads,2) = F(7)
         kOrder = 1
      CASE "PROP"
         'PROP'  N  A  I  V                      ... beam
         'PROP'  N  A  I  V  BCol                ... beam
         'PROP'  N  T                            ... quad
         IF m < 2 THEN errMsg 8, i, j
         IF i > nProps THEN errMsg 5, i, j
         PDAT(i,1) = F(2)
         PDAT(i,2) = F(3)
         PDAT(i,3) = F(4)
         PDAT(i,4) = F(5)
         kOrder = 1
      CASE "MATL"
         'MATL  N  E  U  Alfa  Rho
         'MATL  N  E  U  Alfa  Rho  'STRAIN'     ... plane strain
         'MATL  N  E  U  Alfa  Rho  'SHEAR'      ... shear panel
         IF m < 2 THEN errMsg 8, i, j
         IF i > nMatls THEN errMsg 6, i, j
         u = F(3)
         IF subKey = "STRAIN" THEN u = u + 1
         IF subKey = "SHEAR"  THEN u = u + 2
         EDAT(i,2) = u
         EDAT(i,1) = F(2)
         EDAT(i,3) = F(4)
         EDAT(i,4) = F(5)
         kOrder = 1
      CASE ELSE
         kOrder = 0
         IF lineDOFS = 0 THEN lineDOFS = j
         IF keyWord = "DOFS" AND subKey = "DEF" THEN
            IF kOrder1 OR kOrder2 THEN errMsg 17, j, 0
            subKey = "": kOrder1 = 1
         ELSEIF keyWord = "DOFS" THEN
            kOrder1 = 1
            IF kOrder2 THEN errMsg 17, j, 0
         ELSEIF keyWord = "RACT" OR keyWord = "SPRG" THEN
            if kOrder1 = 0 then errMsg 17, j, 0
            kOrder2 = 1
         ELSEIF keyWord = "NSEQ" THEN
         ELSEIF keyWord = "ENDMODEL" THEN
            if kOrder2 = 0 then errMsg 19, 0, 0
            lineEndModel = j: EXIT DO
         ELSE
            errMsg 8, i, j
         END IF
      END SELECT
   LOOP UNTIL j >= numLines
   IF numBeams + numQuads AND nProps = 0 THEN errMsg 15, 0, 0
   IF numBeams + numQuads AND nMatls = 0 THEN errMsg 16, 0, 0
   IF kOrder THEN errMsg 17, 0, 0
   '------- process grids and elements
   IF LEN(sErr) THEN GOTO exitSub
   FOR i = 1 TO numGrids
      n = NSEQ(i): j = NGRD(i)
      IF n >= 1000000 THEN 'polar coordinates
         n = n - 1000000
         IF n > nGrids OR (n > 0 AND XGR(n) = 0) THEN errMsg 2, n, j
         IF NSEQ(n) > 1000000 THEN errMsg 3, n, j
         x0 = CORD(XGR(n), 1)
         y0 = CORD(XGR(n), 2)
         r = CORD(i,1)
         a = CORD(i,2) * RAD
         CORD(i,1) = x0 + r*COS(a)
         CORD(i,2) = y0 + r*SIN(a)
      ELSEIF n < 0 THEN 'coincident grids
         n = ABS(n)
         IF n > nGrids OR NGRD(n) = 0 THEN errMsg 1, n, j
         CORD(i,1) = CORD(XGR(n),1)
         CORD(i,2) = CORD(XGR(n),2)
         CORD(i,3) = CORD(XGR(n),3)
      END IF
   NEXT i
   FOR i = 1 TO numBeams
      n1 = XGR(NBM(i,1)): n2 = XGR(NBM(i,2))
      IF n1 + n2 = 0 THEN ITERATE
      IF n1 > nGrids OR NGRD(n1) = 0 THEN errMsg 9, n1, i
      IF n2 > nGrids OR NGRD(n2) = 0 THEN errMsg 9, n2, i
      x = CORD(n2,1) - CORD(n1,1)
      y = CORD(n2,2) - CORD(n1,2)
      b = SQR(x*x + y*y)
      a = arcTan(y, x)
      IF b THEN
         ecc = CBM(i,11) - CBM(i,10)
         a = a + ATN(ecc/b)
         b = SQR(b*b + ecc*ecc)
      ELSE
         a = CORD(n1,3)
      END IF
      CBM(i,5) = b
      CBM(i,9) = a
      nProp = CBM(i,1)
      nMatl = CBM(i,2)
      r1 = PDAT(nProp,1)
      r2 = PDAT(nProp,2)
      r4 = PDAT(nProp,3)
      r3 = 0
      IF b THEN
         if nProp > ubound(PDAT) then errMsg 11, i, 0
         if nMatl > ubound(EDAT) then errMsg 12, i, 0
         IF PDAT(nProp,1) = 0 AND PDAT(nProp,2) = 0 THEN errMsg 11, i, 0
         IF EDAT(nMatl,1) = 0 THEN errMsg 12, i, 0
         Pcol = PDAT(nProp,4)
         E = EDAT(nMatl,1)
         CBM(i,7) = EDAT(nMatl,3)
         CBM(i,8) = EDAT(nMatl,4)
         r1 = E*r1/b: rr2 = r2: v = 0
         IF r4 THEN v = 12/b/b*r2/r4
         CBM(i,6) = v
         nType = NBM(i, 3)
         '  nType = 0  standard beam
         '  nType = 1  beam pinned at N2
         '  nType = 2  beam with moment only
         '  nType = 3  pseudo-curved beam
         IF nType = 1 THEN
            r2 = 3*r2*E/b^3/(1+v/4)
            'r3 = -r2*b: r4 = r2*b*b   (ver 1.40)
         ELSEIF nType = 2 THEN
            r4 = r2*E/b
            r2 = 0: r3 = 0
         ELSE
            r2 = 12*E*r2/b^3/(1+v)
            r3 = -r2*b/2
            r4 = r2*b*b/12*(4+v)
         END IF
         IF Pcol > 0 AND rr2 > 0 THEN
            u = b/2*SQR(Pcol/E/rr2)
            uu = 2*u
            d = 2-2*COS(uu)-uu*SIN(uu)
            u2 = 2*u^3*SIN(uu)/d/3
            u3 = uu*u*(1-COS(uu))/d/3
            u4 = u/2*(SIN(uu)-uu*COS(uu))/d
            r2 = r2*u2
            r3 = r3*u3
            r4 = r4*u4
            NBM(i,3) = 4
            CBM(i,12) = Pcol
            CBM(i,13) = u
         END IF
      END IF
      CBM(i,1) = r1
      CBM(i,2) = r2
      CBM(i,3) = r3
      CBM(i,4) = r4
   NEXT i
   FOR i = 1 TO numQuads
      'i = XQD(k): IF i = 0 THEN ITERATE
      n1 = XGR(NQD(i,1)): n2 = XGR(NQD(i,2))
      n3 = XGR(NQD(i,3)): n4 = XGR(NQD(i,4))
      IF n1 > nGrids OR NGRD(n1) = 0 THEN errMsg 10, n1, i
      IF n2 > nGrids OR NGRD(n2) = 0 THEN errMsg 10, n2, i
      IF n3 > nGrids OR NGRD(n3) = 0 THEN errMsg 10, n3, i
      IF n4 > nGrids OR NGRD(n4) = 0 THEN errMsg 10, n4, i
      nProp = CQD(i,1)
      nMatl = CQD(i,2)
      IF PDAT(nProp,1) = 0 THEN errMsg 13, i, 0
      IF EDAT(nMatl,1) = 0 THEN errMsg 14, i, 0
      E = EDAT(nMatl,1)
      u = EDAT(nMatl,2)
      alfa = EDAT(nMatl,3)
      G = E/2/(1+u)
      IF u > 2 THEN 'shear panel
         u = u - 2
         G = E/2/(1+u)
         E = 0
      ELSEIF u > 1 THEN 'plane strain
         u = u - 1
         alfa = alfa*(1+u)
         E = E/(1-u*u)
         u = u/(1-u)
      END IF
      CQD(i,1) = alfa
      CQD(i,2) = EDAT(nMatl, 4)
      CQD(i,3) = PDAT(nProp, 1)
      CQD(i,4) = E
      CQD(i,5) = u
      CQD(i,6) = G
   NEXT i
   '------- read in dofs, reactions, springs, and sequence of grids
   'DOFS' 'DEF'  1  1  0
   'DOFS'  N1    1  1  1
   'RACT'  N1    1  1  1
   'RACT'  N1   -1  1  0
   'DOFS'  N1 'THRU' N2  1  1  0
   'RACT'  N1 'THRU' N2  1  0  1
   'DOFS used to add active dofs at a grid
   'RACT must be defined in active dofs (after all DOFS)
   npr = 3 * nGrids
   DOFS(1) = 1: DOFS(2) = 1: DOFS(3) = 1
   FOR i = 1 TO numGrids
      NSEQ(i) = i
      FOR j = 1 TO 3
         DOF(i,j) = DOFS(j) * SGN(NGRD(i))
      NEXT j
   NEXT i
   k = lineDOFS - 1
   DO
      INCR k
      s = PARSE$(modelData(k), $Comment, 1)
      IF LEN(s) = 0 THEN ITERATE
      m = 20: n = 2
      readFF s, m, n, F(), A()
      IF n < 0 THEN errMsg 8, 0, k
      keyWord = UCASE$(A(1))
      subKey = UCASE$(A(2))
      IF keyWord = "ENDMODEL" THEN
         IF nGridSeq THEN errMsg 18, 0, 0
         EXIT DO
      ELSEIF keyWord = "NSEQ" OR nGridSeq THEN 'read grid sequence
         '  NSEQ  N1  N2  N3...  N20
         '        N21 N22 N23... N40
         FOR i = 1 TO m
            NSEQ(i + nGridSeq) = F(i)
         NEXT i
         nGridSeq = nGridSeq + m
         IF nGridSeq = numGrids THEN nGridSeq = 0
      ELSEIF keyWord = "DOFS" AND subKey = "DEF" THEN
         DOFS(1) = F(1)
         DOFS(2) = F(2)
         DOFS(3) = F(3)
         numDOFS = DOFS(1) + DOFS(2) + DOFS(3)
         npr = numGrids * numDOFS
         FOR i = 1 TO numGrids
         FOR j = 1 TO 3 'active dofs
            DOF(i,j) = DOFS(j) * SGN(NGRD(i))
         NEXT j: NEXT i
      ELSE
         iMin = F(1): iMax = iMin
         IF subKey = "THRU" THEN
            iMax = F(2)
            FOR j = 2 TO 4: F(j) = F(j+1): NEXT j
         END IF
         IF iMin > numGrids THEN errMsg 4, iMin, k
         IF iMax > numGrids THEN errMsg 4, iMax, k
         FOR n = iMin TO iMax
            i = XGR(n): IF i = 0 THEN ITERATE
            FOR j = 1 TO 3
               IF keyWord = "DOFS" THEN
                  npr = npr + F(j+1) - DOF(i,j)
                  DOF(i,j) = F(j+1)
               ELSEIF keyWord = "RACT" AND DOF(i,j) THEN
                  kConstraint = 1
                  IF F(j+1) = 1 THEN DOF(i,j) = -9
                  IF F(j+1) = 0 THEN DOF(i,j) =  1
                  IF F(j+1) < 0 THEN DOF(i,j) = -1
               ELSEIF keyWord = "SPRG" AND DOF(i,j) THEN
                  CORD(i,j+3) = F(j+1)
                  kConstraint = 1
               END IF
            NEXT j
         NEXT n
      END IF
   LOOP
   IF kConstraint = 0 THEN errMsg 19, 0, 0
   '------- process dofs
   'dofs are defined as of now by the following:
   '  DOF(i,j) =  0  not active
   '  DOF(i,j) =  1  free dof
   '  DOF(i,j) = -1  prescribed dof
   '  DOF(i,j) = -9  reaction
   FOR k = 1 TO nGrids
      i = XGR(k): IF i = 0 THEN ITERATE
      FOR j = 1 TO 3  'find if specified displacement
         IF DOF(i,j) = -1 THEN kRot = 2
      NEXT j
      IF CORD(i,3) THEN
         n1 = 1: n2 = 1
         IF DOF(i,1) = 0 OR DOF(i,1) = -9 THEN n1 = 0
         IF DOF(i,2) = 0 OR DOF(i,2) = -9 THEN n2 = 0
         IF n1 = 0 AND n2 THEN
            DOF(i,1) = 1: DOF(i,4) = 1: kRot = 1
         ELSEIF n1 AND n2 = 0 THEN
            DOF(i,2) = 1: DOF(i,4) = 2: kRot = 1
         ELSEIF DOF(i,1) = -1 XOR DOF(i,2) = -1 THEN
            DOF(i,4) = 3: kRot = 1
         END IF
      END IF
   NEXT k
   '------- DOF(i,4) is used to define req'd dof rotations and eliminations
   '        when called for by specifying an angle in a GRID record
   '
   'DOF(i,4) =  -1   polar dofs Ok
   '         =   0   dofs ok
   '         =   1   rotate dofs, eliminate DOF 1 (reaction)
   '         =   2   rotate dofs, eliminate DOF 2 (reaction)
   '         =   3   rotate dofs (one DOF is prescribed)
   nnr = npr + 1: neq = 0
   FOR i = 1 TO numGrids
      n = XGR(NSEQ(i))
      FOR j = 1 TO 3
         IF DOF(n,j) = -9 THEN
            DECR nnr: DOF(n,j) = nnr
         ELSEIF DOF(n,j) THEN
            INCR neq: DOF(n,j) = neq * DOF(n,j)
         END IF
      NEXT j
   NEXT i
   '------- dofs are finally defined as follows:
   'DOF(i,j) = dof number... for j = 1,2,3
   '           1st neq are free(+) OR prescribed(-)
   '           subsequent ones are reactions(+)
   '--------------------------------------------------------
   kcol
   n = KD(neq + 1) - 2
exitSub:
   s = ""
   s = s + "Number of grids:    " + STR$(numGrids) + $CRLF
   s = s + "Number of beams:    " + STR$(numBeams) + $CRLF
   s = s + "Number of quads:    " + STR$(numQuads) + $CRLF
   s = s + "Number of springs:  " + STR$(nSprgs) + $CRLF
   s = s + "Number of equations:" + STR$(neq)    + $CRLF
   s = s + "Stiffness elements :" + STR$(n)    + $CRLF
   IF LEN(sErr) THEN
      sErr = $CRLF + sErr + $CRLF
      CONTROL DISABLE hModelDlg, %IDOK
   ELSE
      runPhase = 1
   END IF
   sModel = s + sErr + $CRLF + "Done processing model"
   CONTROL SET TEXT hModelDlg, %ID_Output, sModel
END SUB

SUB kcol
   LOCAL i AS LONG, j AS LONG, k AS LONG, m AS LONG, n AS LONG
   LOCAL n1 AS LONG, n2 AS LONG, jj AS LONG, ne AS LONG
   LOCAL c AS LONG, nj AS LONG
   REDIM KD(neq+1) AS LONG
   DIM NDOF(8) AS LONG
   FOR i = 1 TO neq
      kd(i+1) = i
   NEXT i
   FOR i = 1 TO numBeams
      jj = 6: n1 = XGR(NBM(i,1)): n2 = XGR(NBM(i,2))
      FOR j = 1 TO 3
         NDOF(j) = ABS(DOF(n1,j))
         NDOF(j+3) = ABS(DOF(n2,j))
      NEXT j
      m = 1000000
      FOR j = 1 TO jj
         n = NDOF(j): IF n > 0 THEN m = MIN(m, n)
      NEXT j
      FOR j = 1 TO jj
         n = NDOF(j): IF n <= neq THEN KD(n+1) = MIN(KD(n+1), m)
      NEXT j
   NEXT i
   FOR i = 1 TO numQuads
      'i = XQD(k): IF i = 0 THEN ITERATE
      jj = 8
      FOR j = 1 TO 4
         nj = XGR(NQD(i,j))
         NDOF(2*j-1) = ABS(DOF(nj,1))
         NDOF(2*j) = ABS(DOF(nj,2))
      NEXT j
      m = 1000000
      FOR j = 1 TO jj
         n = NDOF(j): IF n > 0 THEN m = MIN(m, n)
      NEXT j
      FOR j = 1 TO jj
         n = NDOF(j): IF n <= neq THEN KD(n+1) = MIN(KD(n+1), m)
      NEXT j
   NEXT i
   KD(1) = 2
   FOR i = 1 TO neq
       KD(i+1) = KD(i) - KD(i+1) + i+1
   NEXT i
   nStiff = KD(neq+1)
   IF n > 1000000 THEN errMsg 2, nStiff, 0
   cmax = 0: rms = 0
   FOR i = 1 TO neq
       c = KD(i+1) - KD(i)
       cmax = MAX(cmax, c)
       rms = rms + c*c
   NEXT i
   rms = SQR(rms/neq)
END SUB

SUB stiff
   LOCAL i, j, k, n1, n2, n3 AS LONG
   LOCAL r1, r2, r3, r4 AS DOUBLE
   LOCAL b, a, a1, a2 AS DOUBLE
   LOCAL s, c, ecc1, ecc2 AS DOUBLE
   LOCAL k1, k2, k3 AS DOUBLE
   LOCAL sBeams, sQuads AS STRING
   REDIM STF(nStiff) AS DOUBLE
   DIM NDOF(6) AS LONG
   '------- build stiffness array using direct stiffness method
   FOR i = 1 TO numBeams
      sBeams = "Processing beam: " + STR$(i)
      CONTROL SET TEXT hModelDlg, %ID_Output, sBeams
      r1 = CBM(i,1)
      r2 = CBM(i,2)
      r3 = CBM(i,3)
      r4 = CBM(i,4)
      b  = CBM(i,5): a  = CBM(i,9)
      ecc1 = CBM(i,10): ecc2 = CBM(i,11)
      s = SIN(a): c = COS(a)
      n1 = XGR(NBM(i,1)): n2 = XGR(NBM(i,2))
      FOR j = 1 TO 3
          NDOF(j) = ABS(DOF(n1,j))
          NDOF(j+3) = ABS(DOF(n2,j))
      NEXT j
      a1 = ecc1*r1: a2 = ecc2*r1
      a = r1*c*c+r2*s*s
      kPut NDOF(1), NDOF(1), a
      kPut NDOF(4), NDOF(1), -a
      kPut NDOF(4), NDOF(4), a
      a = (r1-r2)*s*c
      kPut NDOF(2), NDOF(1), a
      kPut NDOF(5), NDOF(1), -a
      kPut NDOF(4), NDOF(2), -a
      kPut NDOF(5), NDOF(4), a
      a = r1*s*s+r2*c*c
      kPut NDOF(2), NDOF(2), a
      kPut NDOF(5), NDOF(2), -a
      kPut NDOF(5), NDOF(5), a
      IF r2 OR r3 OR r4 THEN
         a = c*a1-s*r3
         kPut NDOF(3), NDOF(1), -a
         kPut NDOF(4), NDOF(3), a
         a = s*a1+c*r3
         kPut NDOF(3), NDOF(2), -a
         kPut NDOF(5), NDOF(3), a
         a = c*a2+s*r3
         kPut NDOF(6), NDOF(1), a
         kPut NDOF(6), NDOF(4), -a
         a = s*a2-c*r3
         kPut NDOF(6), NDOF(2), a
         kPut NDOF(6), NDOF(5), -a
         kPut NDOF(6), NDOF(3), -ecc1*a2-r3*b-r4
         kPut NDOF(6), NDOF(6), ecc2*a2+r4
         kPut NDOF(3), NDOF(3), ecc1*a1+r4
      END IF
   NEXT i
   IF LEN(sErr) THEN sBeams = sBeams + $CRLF + sErr
   IF numBeams THEN sBeams = sBeams + $CRLF + "Done processing beams"
   FOR i = 1 TO numQuads
      'i = XQD(k): IF i = 0 THEN ITERATE
      sQuads = "Processing Quad: " + STR$(i)
      CONTROL SET TEXT hModelDlg, %ID_Output, sBeams + sQuads
      kQuad i
   NEXT i
   IF LEN(sErr) THEN sQuads = sQuads + $CRLF + sErr
   IF nQuads THEN sQuads = sQuads + $CRLF + "Done processing quads"
   IF nSprgs THEN
      FOR i = 1 TO numGrids
         k1 = CORD(i,4): k2 = CORD(i,5): k3 = CORD(i,6)
         IF k1 OR k2 THEN
            a = CORD(i,3)
            s = SIN(a): c = COS(a)
            n1 = DOF(i,1): n2 = DOF(i,2)
            kPut n1, n1, k1*c*c+k2*s*s
            kPut n2, n2, k1*s*s+k2*c*c
            kPut n2, n1, (k1-k2)*s*c
         END IF
         IF k3 THEN
            n3 = DOF(i,3): kPut n3, n3, k3
         END IF
      NEXT i
   END IF
   IF numBeams AND numQuads THEN sBeams = sBeams + $CRLF
   sSolve = sBeams + sQuads
   CONTROL SET TEXT hModelDlg, %ID_Output, sSolve
END SUB

SUB kPut(i AS LONG, j AS LONG, a AS DOUBLE)
   LOCAL m AS LONG
   IF i AND (i <= neq) AND j AND (j <= neq) THEN
      m = KD(MAX(i, j)) + ABS(i - j)
      STF(m) = STF(m) + a
   END IF
END SUB

SUB trfm
   LOCAL i AS LONG, j AS LONG, m AS LONG, n AS LONG
   LOCAL n1 AS LONG, n2 AS LONG
   LOCAL a AS DOUBLE, s AS DOUBLE, c AS DOUBLE, sav AS DOUBLE
   LOCAL c1 AS DOUBLE, c2 AS DOUBLE
   '------- stiffness matrix must be transformed when
   '        dofs at a grid are rotated and either:
   '(1) one and only one dof is a reaction
   '(2) one and only one dof is a specified displacement
   '------- rotate stiffnesses when DOF(i, 4) > 0

   IF kRot = 1 THEN
      sSolve = sSolve + $CRLF + "Rotating and eliminating dofs"
      CONTROL SET TEXT hModelDlg, %ID_Output, sSolve
   END IF
   FOR i = 1 TO numGrids
      IF DOF(i,4) > 0 THEN
         a = CORD(i,3)
         j = ABS(DOF(i,1))
         'transform rows and columns j and j+1
         'use k1 and k2 to line up rows j,j+1 and cols j,j+1
         'will temporarily overwrite STF(k1) with STF(k2+1)
         'so that STF(k1)=STF(k2+1) lines up with STF(k1+1)
         n1 = KD(j)-1: n2 = KD(j+1): sav = STF(n1)
         STF(n1) = STF(n2+1)
         s = SIN(a): c = COS(a)
         'transform stiffness rows
         FOR n = j TO neq
            m = KD(n)+n-j
            IF m <= KD(n+1) THEN
               c1 = STF(m): c2 = STF(m-1)
               STF(m)=c*c1+s*c2
               STF(m-1)=c*c2-s*c1
            END IF
         NEXT n
         'transform stiffness columns
         m = n2-n1
         FOR n = 0 TO m-1
            c1 = STF(n1+n): c2 = STF(n2+n)
            STF(n1+n)=c*c1+s*c2
            STF(n2+n)=c*c2-s*c1
         NEXT n
         STF(1)=0: STF(n1)=sav
      END IF
   NEXT i
   '------- now eliminate stiffnesses when DOF(i, 4) = 1,2
   FOR i = 1 TO numGrids
      n = DOF(i,4): IF n = 1 OR n = 2 THEN elim DOF(i,n)
   NEXT i
   '------- stiffnesses for prescribed displacements (DOF(i, j) < 0)
   FOR i = 1 TO numGrids
   FOR j = 1 TO 3
      n = DOF(i,j): IF n < 0 THEN STF(KD(-n)) = 1.D99
   NEXT j: NEXT i
END SUB

SUB elim(BYVAL k AS LONG)
   LOCAL i AS LONG, j AS LONG, m AS LONG, n AS LONG
   m = KD(k+1) - KD(k)
   FOR j = k+1 TO neq
      n = KD(j+1) - KD(j)
      FOR i = 0 TO n-1
         IF j - i = k THEN
            INCR m: DECR n
         ELSE
            STF(KD(j)+i-m) = STF(KD(j)+i)
         END IF
      NEXT i
      KD(j) = KD(j-1) + n
   NEXT j
   FOR i = 1 TO numGrids
   FOR j = 1 TO 3
      m = DOF(i,j): n = ABS(m)
      IF n <= neq THEN
         IF n > k THEN DOF(i,j) = (n-1) * SGN(m)
         IF n = k THEN DOF(i,j) = neq
      END IF
   NEXT j: NEXT i
   DECR neq
END SUB

SUB Dcomp
   LOCAL i AS LONG, j AS LONG, k AS LONG, m AS LONG, n AS LONG
   LOCAL kn AS LONG, kl AS LONG, ku AS LONG, kh AS LONG, klt AS LONG
   LOCAL ki AS LONG, nd AS LONG, s AS STRING, nstf AS LONG
   LOCAL a AS DOUBLE, c AS DOUBLE, e AS DOUBLE
   e = 1: s = "": nstf = KD(neq+1) - 2
   s = s + $CRLF + "Number of equations =" + STR$(neq)
   s = s + $CRLF + "Size of stiffness =" + STR$(nstf)
   s = s + $CRLF + "Maximum active column =" + STR$(cMax)
   s = s + $CRLF + "RMS active column =" + STR$(rms)
   sSolve = sSolve + $CRLF + s
   CONTROL SET TEXT hModelDlg, %ID_Output, sSolve
   FOR n = 1 TO neq
      kn = KD(n)
      kl = kn + 1
      ku = KD(n+1) - 1
      kh = ku - kl
      a = STF(kn)
      IF a <= 0 THEN GOTO notPosDef
      IF kh > 0 THEN
         m = n - kh
         klt = ku
         FOR i = 1 TO kh
            DECR klt: ki = KD(m)
            nd = KD(m+1) - ki - 1
            IF nd > 0 THEN
               k = MIN(i, nd)
               FOR j = 1 TO k
                  STF(klt) = STF(klt) - STF(ki+j)*STF(klt+j)
               NEXT j
            END IF
            INCR m
         NEXT i
      END IF
      IF kh >= 0 THEN
         m = n
         FOR i = kl TO ku
            DECR m: ki = KD(m)
            c = STF(i)/STF(ki)
            STF(kn) = STF(kn) - c*STF(i)
            STF(i) = c
         NEXT i
         a = STF(kn)/a
         e = MIN(a, e)
      END IF
      IF a < eTol THEN GOTO notPosDef
   NEXT n
   STF(1) = e
   s = ""
   s = s + $CRLF + "Minimum pivot ratio = " + STR$(e,5)
   sSolve = sSolve + $CRLF + s
   CONTROL SET TEXT hModelDlg, %ID_Output, sSolve
   runPhase = 2
   EXIT SUB
notPosDef:
   CONTROL DISABLE hModelDlg, %IDOK
   CONTROL SET FOCUS hModelDlg, %IDCANCEL
   FOR i = 1 TO numGrids
      FOR j = 1 TO 3
         IF ABS(DOF(i,j)) = n THEN m = i: n = j: EXIT: EXIT
      NEXT
   NEXT i
   s = ""
   s = s + $CRLF + "STOP - stiffness matrix not positive definite"
   s = s + $CRLF + "Nonpositive pivot at grid" + STR$(m) + ", dof" + STR$(n)
   s = s + $CRLF + "Pivot ratio =" + STR$(a, 4)
   sSolve = sSolve + $CRLF + s
   CONTROL SET TEXT hModelDlg, %ID_Output, sSolve
   rbdofs
END SUB

SUB subcaseDlg
   LOCAL nStyle AS LONG, xstyle AS LONG, wi AS LONG, ht AS LONG, hb AS LONG
   LOCAL i AS LONG, ti AS STRING, s AS STRING
   nStyle=%WS_SYSMENU OR %WS_MINIMIZEBOX
   wi = 150: ht = 60+12*nSubcases: hb = ht - 45
   ti = "Load case scalars": s = "Subcase"
   DIALOG NEW hModelDlg, ti, 10, 0, wi, ht, nStyle TO hSubcaseDlg
   nStyle = %WS_TABSTOP
   xstyle = %WS_EX_CLIENTEDGE
   FOR i = 0 TO nSubcases - 1
      CONTROL ADD LABEL, hSubcaseDlg, -1, s + STR$(i+1), 5, 10+12*i, 40, 10
      CONTROL ADD TEXTBOX, hSubcaseDlg, %ID_Subcase + i, "1.0", 50, 10+12*i, 40, 10, nStyle, xstyle
   NEXT i
   CONTROL ADD BUTTON, hSubcaseDlg, %IDOK, "&OK", 30, hb, 40, 20, 0
   CONTROL ADD BUTTON, hSubcaseDlg, %IDCANCEL, "&Cancel", 80, hb, 40, 20, 0
   DIALOG SHOW MODAL hSubcaseDlg CALL subcaseProc
END SUB

CALLBACK FUNCTION subcaseProc()
   LOCAL i AS LONG, m AS LONG, n AS LONG, s AS STRING, keyWord AS STRING
   SELECT CASE CBMSG
   CASE %WM_INITDIALOG
      '------- read in loads, specified displacements, ...
      DIM F(10) AS DOUBLE, A(2) AS STRING
      i = lineEndModel: nSubcases = 0
      DO
         INCR i
         s = PARSE$(modelData(i), $Comment, 1)
         IF LEN(s) = 0 THEN ITERATE
         m = 10: n = 2
         readFF s, m, n, F(), A()
         IF n < 0 THEN errMsg 8, 0, i
         keyWord = UCASE$(A(1))
         IF keyWord = "SUBCASE" THEN INCR nSubcases
      LOOP UNTIL i = numLines
   CASE %WM_COMMAND
      IF CBCTL = %IDOK THEN
         FOR i = 0 TO nSubcases - 1
            CONTROL GET TEXT CBHNDL, %ID_Subcase + i TO s
            FLC(i+1) = VAL(s)
         NEXT i
         DIALOG END CBHNDL
      ELSEIF CBCTL = %IDCANCEL THEN
         DIALOG END CBHNDL
         DIALOG END hModelDlg
      END IF
   END SELECT
END FUNCTION

SUB loads
   LOCAL i AS LONG, j AS LONG, k AS LONG, m AS LONG, n AS LONG, ld AS LONG
   LOCAL imin AS LONG, imax AS LONG, mk AS LONG, ma AS LONG, mm AS LONG
   LOCAL ss AS STRING, keyWord AS STRING, subKey AS STRING, kGrav AS BYTE
   LOCAL a AS DOUBLE, s AS DOUBLE, c AS DOUBLE, r AS DOUBLE, alfaB AS DOUBLE
   DIM F(10) AS DOUBLE, A(2) AS STRING
   REDIM FBM(numBeams,6) AS DOUBLE, FQD(numQuads,4,3) AS DOUBLE
   REDIM P(neq) AS DOUBLE, PR(npr) AS DOUBLE
   '------- read in loads, specified displacements, ...
   sSolve = "Reading and processing load data"
   CONTROL SET TEXT hModelDlg, %ID_Output, sSolve
   j = lineEndModel
   DO
      INCR j
      ss = PARSE$(modelData(j), $Comment, 1)
      IF LEN(ss) = 0 THEN ITERATE
      m = 10: n = 2
      readFF ss, m, n, F(), A()
      IF n < 0 THEN errMsg 8, 0, j
      keyWord = UCASE$(A(1))
      subKey = UCASE$(A(2))
      IF keyWord = "SUBCASE" THEN
         ld = F(1): ITERATE
      ELSEIF FLC(ld) = 0 THEN
         ITERATE
      END IF
      imin = F(1): imax = imin
      IF subKey = "THRU" THEN
         imax = F(2): DECR m
         FOR k = 2 TO 6: F(k) = F(k+1): NEXT k
      END IF
      FOR k = imin TO imax
         SELECT CASE keyWord
         CASE "LOAD"
         'LOAD' N  P1  P2  P3
         'LOAD' M THRU N  P1  P2  P3
            i = XGR(k)
            s = 0: c = 1
            IF DOF(i,4) <= 0 THEN
               a = CORD(i,3)
               s = SIN(a): c = COS(a)
            END IF
            FOR n = 1 TO 3
               IF n = 1 THEN r = FLC(ld)*(c*F(2)-s*F(3))
               IF n = 2 THEN r = FLC(ld)*(s*F(2)+c*F(3))
               IF n = 3 THEN r = FLC(ld)*F(4)
               mk = DOF(i,n)
               IF mk > 0 AND mk <= neq THEN
                  P(mk) = P(mk) + r
                  PR(mk) = PR(mk) + r
               ELSEIF mk THEN
                  ma = ABS(mk): PR(ma) = PR(ma) - r
               END IF
            NEXT n
         CASE "DISP"
         'DISP' N  D1  D2  D3
         'DISP' M THRU N  D1  D2  D3
            i = XGR(k)
            s = 0: c = 1
            IF DOF(i,4) <= 0 THEN
               a = CORD(i,3)
               s = SIN(a): c = COS(a)
            END IF
            FOR n = 1 TO 3
               IF n = 1 THEN r = FLC(ld)*(c*F(2)-s*F(3))
               IF n = 2 THEN r = FLC(ld)*(s*F(2)+c*F(3))
               IF n = 3 THEN r = FLC(ld)*F(4)
               mk = DOF(i,n): mm = -mk
               IF mk < 0 THEN P(mm) = 1.D99 * r
            NEXT n
         CASE "GRAV"
         'GRAV'  Gx  Gy
            kGrav = 1
            gx = gx + FLC(ld)*F(1)
            gy = gy + FLC(ld)*F(2)
         CASE "BLOAD"
         'BLOAD' N  W1  W2
         'BLOAD' M THRU N  W1  W2
            i = XBM(k)
            IF i THEN
               IF m = 2 THEN F(3) = F(2)
               FBM(i,5) = FBM(i,5) + FLC(ld)*F(2)
               FBM(i,6) = FBM(i,6) + FLC(ld)*F(3)
            END IF
         CASE "BINIT"
         'BINIT' N  Di1  Di2  Di3
         'BINIT' M THRU N  Di1  Di2  Di3
            i = XBM(k)
            IF i THEN
               FOR n = 1 TO 3
                  FBM(i,n) = FBM(i,n) + FLC(ld)*F(m+1)
               NEXT n
            END IF
         CASE "BTEMP"
         'BTEMP' N  Tav  Tgrad
         'BTEMP' M 'THRU' N  Tav  Tgrad
            i = XBM(k)
            IF i THEN
               alfaB = FLC(ld)*CBM(i, 7)*CBM(i, 5)
               FBM(i,1) = FBM(i,1) + F(2)*alfaB
               FBM(i,2) = FBM(i,2) - F(3)*alfaB*CBM(i, 5)/2
               FBM(i,3) = FBM(i,3) - F(3)*alfaB
            END IF
         CASE "QLOAD"
         'QLOAD' N  edge  W1  W2
         'QLOAD' M 'THRU' N  edge  W1  W2
            i = XQD(k)
            IF i THEN
               n = F(2): IF m = 3 THEN F(4) = F(3)
               FQD(i,n,1) = FQD(i,n,1) + FLC(ld)*F(3)
               FQD(i,n,2) = FQD(i,n,2) + FLC(ld)*F(4)
            END IF
         CASE "QTEMP"
         'QTEMP' N  T1  T2  T3  T4
         'QTEMP' N  Tav
            i = XQD(k)
            IF i THEN
               IF NQD(i,4) = NQD(i,3) THEN F(5) = F(4)
               FOR n = 1 TO 4
                  IF m = 2 THEN F(n+1) = F(2)
                  FQD(i,n,3) = FQD(i,n,3) + FLC(ld)*F(n+1)
               NEXT n
            END IF
         CASE ELSE
         END SELECT
         IF LEFT$(keyWord, 1) = "B" THEN NBM(k,0) = -NBM(k,0)
         IF LEFT$(keyWord, 1) = "Q" THEN NQD(k,0) = -NQD(k,0)
      NEXT k
   LOOP UNTIL J = numLines
   FOR i = 1 TO numBeams
      IF kGrav OR NBM(i,0) THEN pBeam i
      NBM(i,0) = ABS(NBM(i,0))
   NEXT i
   FOR i = 1 TO numQuads
      IF kGrav OR NQD(i,0) THEN pQuad i
      NQD(i,0) = ABS(NQD(i,0))
   NEXT k
END SUB

SUB pBeam(i AS LONG)
   LOCAL n1 AS LONG, n2 AS LONG, iType AS LONG
   LOCAL j AS LONG, m AS LONG, ma AS LONG
   LOCAL b AS DOUBLE, alfa AS DOUBLE, s AS DOUBLE, c AS DOUBLE
   LOCAL e1 AS DOUBLE, e2 AS DOUBLE, e3 AS DOUBLE, v AS DOUBLE
   LOCAL r1 AS DOUBLE, r2 AS DOUBLE, r3 AS DOUBLE, r4 AS DOUBLE
   LOCAL rho AS DOUBLE, a AS DOUBLE, ecc1 AS DOUBLE, ecc2 AS DOUBLE
   LOCAL q0 AS DOUBLE, q1 AS DOUBLE, q2 AS DOUBLE, u AS DOUBLE, f AS DOUBLE
   DIM P6(6) AS DOUBLE
   '------- compute P, PR due to distr loads and strains in undeformed beam i
   n1 = XGR(NBM(i,1)): n2 = XGR(NBM(i,2))
   iType = NBM(i,3)
   b = CBM(i,5)
   alfa = CBM(i,7)
   e1 = FBM(i,1)
   e2 = FBM(i,2)
   e3 = FBM(i,3)
   r1 = CBM(i,1)
   r2 = CBM(i,2)
   r3 = CBM(i,3)
   r4 = CBM(i,4)
   v  = CBM(i,6)
   rho = CBM(i,8)
   a   = CBM(i,9)
   ecc1 = CBM(i,10)
   ecc2 = CBM(i,11)
   s = SIN(a): c = COS(a)
   q0  = rho*(gx*c+gy*s)
   rho = rho*(gy*c-gx*s)
   q1 = FBM(i,5) + rho
   q2 = FBM(i,6) + rho
   FBM(i,4) = -q0*b/2
   FBM(i,5) = -((7*q2+3*q1)/20+(2*q2+q1)*v/6)*b/(1+v)
   FBM(i,6) = ((3*q2+2*q1)/60+(q1+q2)*v/24)*b*b/(1+v)
   IF iType = 1 THEN
      FBM(i,5) = -((11*q2+4*q1)/40+(2*q2+q1)*v/12)*b/(1+v/4)
      FBM(i,6) = 0
   ELSEIF iType = 3 THEN
      FBM(i,6) = (q2-q1)/120*b*b/(1+v)
   END IF
   FBM(i,4) = FBM(i,4) - r1*e1
   FBM(i,5) = FBM(i,5) - r2*e2 - r3*e3
   FBM(i,6) = FBM(i,6) - r3*e2 - r4*e3
   FBM(i,1) = FBM(i,4) + q0*b
   FBM(i,2) = FBM(i,5) + (q1+q2)*b/2
   FBM(i,3) = FBM(i,6) + FBM(i,5)*b + (q1+2*q2)*b*b/6
   IF iType = 4 THEN
      u = CBM(i,13)
      f = 3*(1-u/TAN(u))/u/u
      FBM(i,3) = FBM(i,3)*f
      FBM(i,6) = FBM(i,6)*f
   END IF
   IF DOF(n1,4) > 0 THEN a = a - CORD(n1,3)
   c = COS(a): s = SIN(a)
   P6(1) = FBM(i,1)*c - FBM(i,2)*s
   P6(2) = FBM(i,1)*s + FBM(i,2)*c
   P6(3) = FBM(i,3) - FBM(i,1)*ecc1
   a = CBM(i,9)
   IF DOF(n2,4) > 0 THEN a = a - CORD(n2,3)
   c = COS(a): s = SIN(a)
   P6(4) = -FBM(i,4)*c + FBM(i,5)*s
   P6(5) = -FBM(i,4)*s - FBM(i,5)*c
   P6(6) = -FBM(i,6) + FBM(i,4)*ecc2
   FOR j = 1 TO 6
      IF j <= 3 THEN m = DOF(n1,j) ELSE m = DOF(n2,j-3)
      IF m > 0 AND m <= neq THEN
         P(m) = P(m) + P6(j)
         PR(m) = PR(m) + P6(j)
      ELSEIF m THEN
         ma = ABS(m)
         PR(ma) = PR(ma) - P6(j)
      END IF
   NEXT j
END SUB

SUB rhsol
   LOCAL i AS LONG, j AS LONG, m AS LONG, n AS LONG
   LOCAL kl AS LONG, ku AS LONG, c AS DOUBLE
   sSolve = sSolve + $CRLF + "Running back substitution"
   CONTROL SET TEXT hModelDlg, %ID_Output, sSolve
   FOR n = 1 TO neq
      kl = KD(n) + 1
      ku = KD(n+1) - 1
      IF ku >= kl THEN
         m = n
         FOR i = kl TO ku
            DECR m: c = STF(i)
            P(n) = P(n) - c*P(m)
         NEXT i
      END IF
   NEXT n
   FOR n = 1 TO neq
      c = STF(KD(n))
      P(n) = P(n)/c
   NEXT n
   IF neq = 1 THEN EXIT SUB
   n = neq
   FOR j = 2 TO neq
      kl = KD(n) + 1
      ku = KD(n+1) - 1
      IF ku >= kl THEN
         m = n
         FOR i = kl TO ku
            DECR m: c = STF(i)
            P(m) = P(m) - c*P(n)
         NEXT i
      END IF
      DECR n
   NEXT j
END SUB

SUB stress
   LOCAL i, j, k, m, n, n1, n2, ma, nn, iType AS LONG
   LOCAL ii, jj, node, m1, m2, iPolar, nq, nnq AS LONG
   LOCAL u, v, a, b, ecc1, ecc2, x, y, f1, f2, f3, bcol AS DOUBLE
   LOCAL r1, r2, r3, r4, c, s, c1, s1, c2, s2, detJ, dNom AS DOUBLE
   LOCAL u1, v1, u2, v2, px, py, sx, sy, sxy, diff, eps AS DOUBLE
   DIM PEL(8) AS DOUBLE, UEL(8) AS DOUBLE
   DIM NDOF(8) AS LONG, XC(4) AS DOUBLE, YC(4) AS DOUBLE

   runPhase = 3
   sSolve = sSolve + $CRLF + "Computing element forces"
   CONTROL SET TEXT hModelDlg, %ID_Output, sSolve
   CONTROL SET TEXT hModelDlg, %IDOK, "Finish"
   CONTROL SET SIZE hModelDlg, %IDCANCEL, 0, 0
   'compute potential energy due to applied loads
   v = 0
   FOR i = 1 TO numGrids
      FOR j = 1 TO 3
         m = DOF(i, j)
         IF m > 0 AND m <=neq THEN v = v + PR(m) * P(m)
      NEXT j
   NEXT i
   '------- compute element forces and reactions due to beam deformation
   '------- compute strain energy for beams
   FOR i = 1 TO numBeams
      '------- first, compute beam displacements
      n1 = XGR(NBM(i,1)): n2 = XGR(NBM(i,2)): iType = NBM(i,3)
      FOR j = 1 TO 6
         IF j <= 3 THEN m = ABS(DOF(n1,j)) ELSE m = ABS(DOF(n2,j-3))
         IF m AND m <= neq THEN UEL(j) = P(m) ELSE UEL(j) = 0
      NEXT j
      '------- next, compute beam element forces
      'remember that solution coordinates were x,y unless axes were rotated.
      'solution axes were rotated by CORD(n,3) only if DOF(n,4) > 0
      a = CBM(i,9)
      IF DOF(n1,4) > 0 THEN a = a - CORD(n1,3)
      c1 = COS(a): s1 = SIN(a)
      a = CBM(i,9)
      IF DOF(n2,4) > 0 THEN a = a - CORD(n2,3)
      c2 = COS(a): s2 = SIN(a)
      u1 = c1*UEL(1) + s1*UEL(2)
      v1 = c1*UEL(2) - s1*UEL(1)
      u2 = c2*UEL(4) + s2*UEL(5)
      v2 = c2*UEL(5) - s2*UEL(4)
      r1 = CBM(i,1)
      r2 = CBM(i,2)
      r3 = CBM(i,3)
      r4 = CBM(i,4)
      b  = CBM(i,5)
      ecc1 = CBM(i,10)
      ecc2 = CBM(i,11)
      f1 = r1*((u2-u1) + ecc1*UEL(3) - ecc2*UEL(6))
      f2 = r2*(v2-v1) + r3*(UEL(3)+UEL(6))
      f3 = r3*(v2-v1) - (r3*b+r4)*UEL(3) + r4*UEL(6)
      IF iType = 1 THEN f3 = 0
      bcol = CBM(i,12)*(v2-v1)
      FBM(i,4) = FBM(i,4) + f1
      FBM(i,5) = FBM(i,5) + f2
      FBM(i,6) = FBM(i,6) + f3
      FBM(i,1) = FBM(i,1) + f1
      FBM(i,2) = FBM(i,2) + f2
      FBM(i,3) = FBM(i,3) + f3 + f2*b + bcol
      'define PEL() in x,y coordinates
      PEL(1) = f1*c1 - f2*s1
      PEL(2) = f1*s1 + f2*c1
      PEL(3) = f3 + f2*b + bcol - f1*ecc1
      PEL(4) = -f1*c2 + f2*s2
      PEL(5) = -f1*s2 - f2*c2
      PEL(6) = -f3 + f1*ecc2
      '------- now compute strain energy of beams
      '------- also, compute reactions due to beam forces
      FOR j = 1 TO 6
         IF j <= 3 THEN m = DOF(n1,j) ELSE m = DOF(n2,j-3)
         ma = ABS(m)
         IF m < 0 OR m > neq THEN
            PR(ma) = PR(ma) - PEL(j)
         ELSEIF ma THEN
            PR(ma) = PR(ma) + PEL(j)
         END IF
      NEXT j
      IF NBM(i,3) = 3 THEN 'rotate beam forces if arc beam
         a = CBM(i,9) - CORD(n1,3)
         c1 = COS(a): s1 = SIN(a)
         a = CBM(i,9) - CORD(n2,3)
         c2 = COS(a): s2 = SIN(a)
         x = FBM(i,1): y = FBM(i,2)
         FBM(i,1) =  x*s1 + y*c1
         FBM(i,2) = -x*c1 + y*s1
         x = FBM(i,4): y = FBM(i,5)
         FBM(i,4) =  x*s2+y*c2
         FBM(i,5) = -x*c2+y*s2
      END IF
   NEXT i

   '------- compute element forces and reactions due to quad deformation
   '------- also, compute strain energy for quads
   FOR nq = 1 TO numQuads
      'nq = XQD(nnq): IF nq = 0 THEN ITERATE
      '------- first, compute quad displacements in X, Y
      IF NQD(nq,4) = NQD(nq,3) THEN n = 6 ELSE n = 8
      nn = n/2
      FOR k = 1 TO nn
         node = XGR(NQD(nq,k))
         s = 0: c = 1
         IF DOF(node,4) > 0 THEN
            a = CORD(node,3)
            s = SIN(a): c = COS(a)
         END IF
         m1 = DOF(node,1)
         m2 = DOF(node,2)
         NDOF(2*k-1) = m1
         NDOF(2*k) = m2
         px = 0: py = 0
         IF m1 AND m1 <= neq THEN px = P(ABS(m1))
         IF m2 AND m2 <= neq THEN py = P(ABS(m2))
         UEL(2*k-1) = px*c - py*s
         UEL(2*k) = px*s + py*c
      NEXT k
      '------- next, compute quad element forces in X, Y
      FOR i = 1 TO n
         m = n
         k = 7+i-m
         PEL(i) = 0
         FOR j = 1 TO n
            IF j <= i THEN k = k+m: DECR m ELSE INCR k
            PEL(i) = PEL(i) - CQD(nq,k)*UEL(j)
         NEXT j
      NEXT i
      '------- now compute strain energy of quads
      '------- also, compute reactions due to quad forces
      FOR k = 1 TO nn
         px = PEL(2*k-1)
         py = PEL(2*k)
         node = XGR(NQD(nq,k))
         s = 0: c = 1
         IF DOF(node,4) > 0 THEN
            a = CORD(node,3)
            s = SIN(a): c = COS(a)
         END IF
         PEL(2*k-1) = px*c + py*s
         PEL(2*k) = -px*s+py*c
         FOR i = 1 TO 2
            j = 2*k - 2+i
            m = NDOF(j): ma = ABS(m)
            IF m < 0 OR m > neq THEN
               PR(ma) = PR(ma) - PEL(j)
            ELSEIF ma THEN
               PR(ma) = PR(ma) + PEL(j)
            END IF
         NEXT i
      NEXT k
      '------- compute quad stresses, and rotate them if all grids of quad are polar
      D(1) = CQD(nq,4)
      D(2) = CQD(nq,5)
      D(3) = CQD(nq,6)
      D(4) = CQD(nq,7)
      iPolar = 1
      FOR j = 1 TO 4
         node = XGR(NQD(nq,j))
         IF DOF(node,4) >= 0 THEN iPolar = 0
         XC(j) = CORD(node,1)
         YC(j) = CORD(node,2)
      NEXT j
      k = 0
      FOR ii = 1 TO 2
      FOR jj = 1 TO 2
         INCR k: x = 0: y = 0
         quadJ ii, jj, nq, detJ
         FOR i = 1 TO 3
         FOR j = 1 TO 8
            FQD(nq,k,i) = FQD(nq,k,i) + B(i,j)*UEL(j)
         NEXT j: NEXT i
         a = FQD(nq,k,1)
         FQD(nq,k,1) = D(1)*a
         FQD(nq,k,2) = D(2)*a + D(3)*FQD(nq,k,2)
         FQD(nq,k,3) = D(4)*FQD(nq,k,3)
         IF iPolar THEN
            FOR j = 1 TO 4
               c1 = (1+XII(j)*GAUSS(ii))/4
               c2 = (1+ETA(j)*GAUSS(jj))/4
               x = x + 4*c1*c2*XC(j)
               y = y + 4*c1*c2*YC(j)
            NEXT j
            a = arcTan(y, x)
            s = SIN(a): c = COS(a)
            sx = FQD(nq, k, 1)
            sy = FQD(nq, k, 2)
            sxy = FQD(nq, k, 3)
            FQD(nq, k, 1) = c*c*sx + s*s*sy + 2*c*s*sxy
            FQD(nq, k, 2) = s*s*sx + c*c*sy - 2*c*s*sxy
            FQD(nq, k, 3) = c*s*(sx-sy) + (c*c-s*s)*sxy
         END IF
      NEXT jj: NEXT ii
   NEXT nq
   '------- compute spring strain energy and reactions
   IF nSprgs THEN
      FOR i = 1 TO numGrids
      FOR j = 1 TO 3
         m = DOF(i,j): ma = ABS(m)
         c = CORD(i,j+3)
         IF m THEN PR(ma) = PR(ma) - c*P(ma)
      NEXT j: NEXT i
   END IF
   '------- compute difference of potential and strain energy
   u = 0
   FOR i = 1 TO numGrids
   FOR j = 1 TO 3
      m = DOF(i,j)
      IF m > 0 AND m <=neq THEN u = u + P(m)*PR(m)
   NEXT j: NEXT i
   '------- compare energy difference to potential energy for error measure
   eps = u / v
   IF eps < eTol THEN eps = 0
   sSolve = sSolve + $CRLF + $CRLF + "Solution error measure = " + STR$(eps, 4)
   CONTROL SET TEXT hModelDlg, %ID_Output, sSolve
   '------- compute displacements and reactions in rotated dofs
   'rotate solution axes from x,y -> u,v unless DOF(i,4) > 0, in
   'which case, axes already rotated to u,v before solution process
   FOR i = 1 TO numGrids
      a = CORD(i,3)
      IF DOF(i,4) <= 0 AND a THEN
         s = SIN(a): c = COS(a)
         m = ABS(DOF(i,1))
         IF m AND m <= neq THEN
            x = P(m): y=P(m+1)
            P(m) = x*c + y*s
            P(m+1) = y*c - x*s
            x = PR(m): y=PR(m+1)
            PR(m) = x*c + y*s
            PR(m+1) = y*c - x*s
         ELSEIF m THEN
            x = PR(m): y = PR(m-1)
            PR(m) = x*c + y*s
            PR(m-1) = y*c - x*s
         END IF
      END IF
   NEXT i
END SUB

SUB displayResults
   LOCAL nStyle, nCount AS LONG
   LOCAL ti AS STRING
   ti = "Finite Element Results"
   nStyle = %WS_SYSMENU OR %WS_THICKFRAME
   DIALOG NEW 0, ti, , , 260, 285, nStyle TO hDispDlg
   CONTROL ADD FRAME, hDispDlg, -1, "", 5, 2, 140, 30
   nStyle = %WS_GROUP OR %WS_TABSTOP
   CONTROL ADD OPTION, hDispDlg, %ID_Deflns, "Deflections", 15, 10, 50, 10, nStyle
   CONTROL ADD OPTION, hDispDlg, %ID_Reacts, "Reactions", 15, 20, 50, 10, %BS_RIGHT
   CONTROL ADD OPTION, hDispDlg, %ID_Forces, "Beam Forces", 80, 10, 60, 10, %BS_RIGHT
   CONTROL ADD OPTION, hDispDlg, %ID_Stress, "Quad stresses", 80, 20, 60, 10, %BS_RIGHT
   CONTROL ADD CHECKBOX, hDispDlg,%ID_AvgStress, "&Averge stresses", 280, 20, 80, 10, nStyle
   nStyle = %WS_VSCROLL OR %LBS_DISABLENOSCROLL OR %LBS_USETABSTOPS
   CONTROL ADD LISTBOX, hDispDlg, %ID_Results, , 5, 50, 250, 175, nStyle, %WS_EX_CLIENTEDGE
   CONTROL ADD LABEL, hDispDlg, %ID_Hdr0, "", 5, 40, 28, 10, %SS_CENTER, %WS_EX_STATICEDGE
   CONTROL ADD LABEL, hDispDlg, %ID_Hdr1, "", 33, 40, 27, 10, %SS_CENTER, %WS_EX_STATICEDGE
   CONTROL ADD LABEL, hDispDlg, %ID_Hdr2, "", 60, 40, 60, 10, %SS_CENTER, %WS_EX_STATICEDGE
   CONTROL ADD LABEL, hDispDlg, %ID_Hdr3, "", 120, 40, 60, 10, %SS_CENTER, %WS_EX_STATICEDGE
   CONTROL ADD LABEL, hDispDlg, %ID_Hdr4, "", 180, 40, 60, 10, %SS_CENTER, %WS_EX_STATICEDGE
   CONTROL ADD BUTTON, hDispDlg, %ID_PrintResults, "&Print", 25, 222, 60, 25, %WS_TABSTOP
   CONTROL ADD BUTTON, hDispDlg, %ID_Copy, "C&opy", 100, 222, 60, 25, %WS_TABSTOP
   CONTROL ADD BUTTON, hDispDlg, %IDCANCEL, "&Cancel", 175, 222, 60, 25, %WS_TABSTOP
   DIALOG SHOW MODELESS hDispDlg CALL dispResultsProc
END SUB

CALLBACK FUNCTION dispResultsProc
   LOCAL m, n, x, y AS LONG  ', dlgWidth, dlgHeight AS LONG
   LOCAL hFont, i, j, k AS LONG
   LOCAL lptr AS LONG PTR
   LOCAL s AS STRING
   STATIC sClipbd AS STRING
   STATIC xDlg, yDlg, wiDlg, htDlg AS LONG  ', wList AS LONG
   STATIC nOpt, stressDlg, avg AS LONG  ', xx, yy AS LONG
   DIM sLine(4) AS STRING
   DIM tabstops(6) AS STATIC LONG
   SELECT CASE CBMSG
   CASE %WM_INITDIALOG
      tabstops(0) = 5
      tabstops(1) = 30
      tabstops(2) = 60
      tabstops(3) = 120
      tabstops(4) = 180
      tabstops(5) = 240
      tabstops(6) = 300
      lptr=VARPTR(tabstops(0))
      CONTROL SEND CBHNDL, %ID_Results, %LB_SETTABSTOPS, 7, lptr
      FONT NEW "Courier New", 9 TO hFont
      control set font cb.hndl, %ID_Results, hFont
      'hFont = makeFont(hDC, fontType , 9)
      'CONTROL SEND CBHNDL, %ID_Results, %WM_SETFONT, hFont, %TRUE
      IF numBeams = 0 THEN CONTROL DISABLE CBHNDL, %ID_Forces
      IF numQuads = 0 THEN CONTROL DISABLE CBHNDL, %ID_Stress
      DIALOG GET LOC hDlg TO x, y
      xDlg = x + 20: yDlg = y + 20
      DIALOG SET LOC CB.HNDL, xDlg, yDlg
      stressDlg = 0: av = 0
      DIALOG POST CB.HNDL, %WM_COMMAND, %ID_Deflns, 0
   CASE %WM_SIZE
      DIALOG GET LOC CB.HNDL TO xDlg, yDlg
      DIALOG GET SIZE CB.HNDL TO wiDlg, htDlg
      IF stressDlg THEN wiDlg = 385 ELSE wiDlg = 270
      DIALOG SET SIZE CB.HNDL, wiDlg, htDlg
      CONTROL SET SIZE CB.HNDL, %ID_Results, wiDlg - 24, htDlg - 105   'wList, htDlg - 80  'dlgHeight - 80
      y = htDlg - 52  'dlgHeight - 30
      CONTROL SET LOC CB.HNDL, %ID_PrintResults, 25, y
      CONTROL SET LOC CB.HNDL, %ID_Copy, 100, y
      CONTROL SET LOC CB.HNDL, %IDCANCEL, 175, y
   CASE %WM_COMMAND
      IF CBCTL = %ID_AvgStress THEN
         av = 1 - av
         avg = av
         CONTROL SET CHECK CBHNDL, nOpt, avg
         DIALOG SEND CBHNDL, %WM_COMMAND, %ID_Stress, 0
      ELSEIF CBCTL >= %ID_Deflns THEN
         IF CBCTL < %ID_Stress AND stressDlg THEN 'back to original window
            wiDlg = 270: IF stressDlg THEN xDlg = xDlg + 60
            stressDlg = 0
            DIALOG SET LOC CBHNDL, xDlg, yDlg
            DIALOG SET SIZE CBHNDL, wiDlg, htDlg
            CONTROL SET SIZE CBHNDL, %ID_Results, wiDlg - 24, htDlg - 105
            CONTROL KILL CBHNDL, %ID_Hdr5
            CONTROL KILL CBHNDL, %ID_Hdr6
         ELSEIF CBCTL = %ID_Stress AND stressDlg = 0 THEN 'resize and relocate window
            stressDlg = 1
            wiDlg = 385: xDlg = xDlg - 60
            DIALOG SET LOC CBHNDL, xDlg, yDlg
            DIALOG SET SIZE CBHNDL, wiDlg, htDlg
            CONTROL SET SIZE CBHNDL, %ID_Results, wiDlg - 24, htDlg - 105
            CONTROL ADD LABEL, CBHNDL,%ID_Hdr5, "", 240, 40, 60, 10, %SS_CENTER, %WS_EX_STATICEDGE
            CONTROL ADD LABEL, CBHNDL,%ID_Hdr6, "", 300, 40, 60, 10, %SS_CENTER, %WS_EX_STATICEDGE
            CONTROL SET TEXT CBHNDL, %ID_Hdr2, " Sx "
            CONTROL SET TEXT CBHNDL, %ID_Hdr3, " Sy "
            CONTROL SET TEXT CBHNDL, %ID_Hdr4, " Sxy"
            CONTROL SET TEXT CBHNDL, %ID_Hdr5, "Prin"
            CONTROL SET TEXT CBHNDL, %ID_Hdr6, "vonM"
         END IF
         CONTROL SET CHECK CBHNDL, nOpt, 0
         CONTROL SET CHECK CBHNDL, CBCTL, 1: nOpt = CBCTL - %ID_Deflns + 1
         LISTBOX RESET CBHNDL, %ID_Results
         IF CBCTL = %ID_Deflns OR CBCTL = %ID_Reacts THEN
            CONTROL SET TEXT CBHNDL, %ID_Hdr0, ""
            CONTROL SET TEXT CBHNDL, %ID_Hdr1, "Grid"
            IF CBCTL = %ID_Deflns THEN
               CONTROL SET TEXT CBHNDL, %ID_Hdr2, "u Defl"
               CONTROL SET TEXT CBHNDL, %ID_Hdr3, "v Defl"
               CONTROL SET TEXT CBHNDL, %ID_Hdr4, CHR$(248) + " Defl"
            ELSE
               CONTROL SET TEXT CBHNDL, %ID_Hdr2, "u Ract"
               CONTROL SET TEXT CBHNDL, %ID_Hdr3, "v Ract"
               CONTROL SET TEXT CBHNDL, %ID_Hdr4, CHR$(248) + " Ract"
            END IF
         ELSEIF CBCTL = %ID_Forces THEN
            CONTROL SET TEXT CBHNDL, %ID_Hdr0, "Beam"
            CONTROL SET TEXT CBHNDL, %ID_Hdr1, "Grid"
            CONTROL SET TEXT CBHNDL, %ID_Hdr2, "Axial"
            CONTROL SET TEXT CBHNDL, %ID_Hdr3, "Shear"
            CONTROL SET TEXT CBHNDL, %ID_Hdr4, "Moment"
         ELSEIF CBCTL = %ID_Stress THEN
            IF av THEN 'show average quad stresses
               CONTROL SET TEXT CBHNDL, %ID_Hdr0, ""
               CONTROL SET TEXT CBHNDL, %ID_Hdr1, "Quad"
            ELSE  'show quad stresses at each defining grid
               CONTROL SET TEXT CBHNDL, %ID_Hdr0, "Quad"
               CONTROL SET TEXT CBHNDL, %ID_Hdr1, "Grid"
            END IF
         END IF
         sClipbd = ""
         FOR i = 0 TO 6
            CONTROL GET TEXT CB.HNDL, %ID_Hdr0 + i TO s
            sClipbd = sClipbd + $TAB + s
         NEXT i
         sClipbd = sClipbd + $CRLF
         n = nGrids
         IF nOpt = 3 THEN n = numBeams
         IF nOpt = 4 THEN n = numQuads
         FOR i = 1 TO n
            m = getResultLines(i, nOpt, sLine())
            FOR j = 1 TO m
               IF LEN(sLine(j)) THEN
                  LISTBOX ADD CBHNDL,%ID_Results, sLine(j)
                  sClipbd = sClipbd + sLine(j) + $CRLF
               END IF
            NEXT j
         NEXT i
      ELSEIF CBCTL = %ID_Results THEN
         CONTROL SET FOCUS CBHNDL, nOpt
      ELSEIF CBCTL = %ID_PrintResults OR CBCTL = %ID_Copy THEN
         IF nOpt = 1 THEN m = 1: s = "displacements"
         IF nOpt = 2 THEN m = 2: s = "reactions"
         IF nOpt = 3 THEN m = 3: s = "beam forces"
         IF nOpt = 4 THEN m = 4: s = "quad stresses"
         IF CBCTL = %ID_PrintResults THEN
            s = "Print these " + s + " Now?"
            n = MSGBOX(s, %MB_YESNO + %MB_ICONQUESTION, "Print Results")
            IF n = %IDYES THEN printSoln m
         ELSE
            s = "Copy these " + s + " to clipboard?"
            n = MSGBOX(s, %MB_YESNO + %MB_ICONQUESTION, "Copy Results to Clipboard")
            IF n = %IDYES THEN SetClipboardText sClipbd
         END IF
         CONTROL SEND CBHNDL, CBCTL, %BM_SETSTYLE, %BS_PUSHBUTTON, %TRUE
         CONTROL SET FOCUS CBHNDL, nOpt
      ELSEIF CBCTL = %IDCANCEL THEN
         DIALOG END CBHNDL
      END IF
   case %WM_DESTROY 
      control set focus hDlg, %ID_Textbox  
   END SELECT
END FUNCTION

FUNCTION getResultLines(k AS LONG, nOpt AS LONG, s() AS STRING) AS LONG
   'nOpt = 1  displacements
   'nOpt = 2  reactions
   'nOpt = 3  beam forces
   'nOpt = 4  quad stresses
   '----------------------------------------------------------------
   LOCAL i AS LONG, j AS LONG, m AS LONG, n AS LONG, nLines AS LONG
   LOCAL c AS DOUBLE, s AS DOUBLE
   LOCAL sTab0 AS STRING, sTab AS STRING
   REDIM s(4) AS STRING
   DIM C(4) AS DOUBLE
   sTab0 = $TAB: sTab = $TAB
   IF prn THEN sTab0 = "": sTab = "   "
   IF nOpt = 1 THEN 'displacements
      nLines = 1: i = XGR(k)
      IF i THEN
         s(1) = sTAB0 + sTAB0 + Ifmt(k)
         FOR j = 1 TO 3
            m = ABS(DOF(i,j)): C(j) = 0
            IF m AND m <= neq THEN C(j)=P(m)
            s(1) = s(1) + sTAB + fmt(C(j))
         NEXT j
      END IF
   ELSEIF nOpt = 2 THEN 'reactions
      i = XGR(k)
      IF i THEN
         s(1) = sTab0 + sTab0 + Ifmt(k)
         FOR j = 1 TO 3
            m = DOF(i,j): C(j) = 0
            IF m < 0 OR m > neq THEN
               C(j) = PR(ABS(m)): nLines = 1
            ELSEIF CORD(i,j+3) > 0 THEN
               C(j) = -CORD(i,j+3)*P(m): nLines = 1
            END IF
            s(1) = s(1) + sTab + fmt(C(j))
         NEXT j
      END IF
   ELSEIF nOpt = 3 THEN 'beam forces
      nLines = 2: i = NBM(k,0)
      IF i THEN
         s(1) = sTab0 + Ifmt(i) + sTab + Ifmt(NBM(k,1))
         s(2) = sTab0 + Ifmt(i) + sTab + Ifmt(NBM(k,2))
         FOR j = 1 TO 3
            s(1) = s(1) + sTab + fmt(FBM(k,j))
            s(2) = s(2) + sTab + fmt(FBM(k,j+3))
         NEXT j
      END IF
   ELSEIF nOpt = 4 THEN 'quad stresses
      LOCAL c1 AS DOUBLE, c2 AS DOUBLE
      LOCAL prin AS DOUBLE, vonM AS DOUBLE
      DIM SFQD(4,3) AS DOUBLE
      i = NQD(k,0)
      IF av THEN
         FOR j = 1 TO 3
            FOR n = 1 TO 4
               C(j) = C(j) + FQD(k,n,j)
            NEXT n
            C(j) = C(j)/4
         NEXT j
         c1 = (C(1) + C(2))/2
         c2 = SQR(((C(1)-C(2))^2)/4 + C(3)^2)
         prin = SGN(c1)*(ABS(c1)+c2)
         vonM = SQR((C(1)^2 + C(2)^2) - C(1)*C(2) + 3*C(3)^2)
         s(1) = sTab0 + sTab0 + Ifmt(i) + sTab + fmt(C(1))
         s(1) = s(1) + sTab + fmt(C(2)) + sTab + fmt(C(3))
         s(1) = s(1) + sTab + fmt(prin) + sTab + fmt(vonM)
         nLines = 1
      ELSE
         FOR j = 1 TO 3
            C(0) = ( FQD(k,1,j)+FQD(k,2,j)+FQD(k,3,j)+FQD(k,4,j))/4
            C(1) = (-FQD(k,1,j)-FQD(k,2,j)+FQD(k,3,j)+FQD(k,4,j))/2.309401
            C(2) = (-FQD(k,1,j)+FQD(k,2,j)-FQD(k,3,j)+FQD(k,4,j))/2.309401
            C(3) = ( FQD(k,1,j)-FQD(k,2,j)-FQD(k,3,j)+FQD(k,4,j))/13.333333
            FOR n = 1 TO 4
               SFQD(n,j)=C(0) + XII(n)*C(1) + ETA(n)*C(2) + XII(n)*ETA(n)*C(3)
            NEXT n
         NEXT j
         IF NQD(i,4) = NQD(i,3) THEN nLines = 3 ELSE nLines = 4
         FOR n = 1 TO nLines
            c1 = (SFQD(n,1) + SFQD(n,2))/2
            c2 = SQR(((SFQD(n,1) - SFQD(n,2))^2)/4 + SFQD(n,3)^2)
            prin = SGN(c1)*(ABS(c1)+c2)
            vonM = SQR(SFQD(n,1)^2 + SFQD(n,2)^2 - SFQD(n,1)*SFQD(n,2) + 3*SFQD(n,3)^2)
                                            '...sign error on last term found by Zensin
            j = NQD(i,n)
            s(n) = sTAB0 + Ifmt(i)+ sTab + Ifmt(j) + sTab + fmt(SFQD(n,1))
            s(n) = s(n) + sTab + fmt(SFQD(n,2)) + sTab + fmt(SFQD(n,3))
            s(n) = s(n) + sTab + fmt(prin) + sTab + fmt(vonM)
         NEXT n
      END IF
   END IF
   FUNCTION = nLines
END FUNCTION

FUNCTION SetClipboardText(BYVAL sText AS STRING) AS LONG
   'Create a global memory object and copy the data into it
   LOCAL hData AS DWORD, hGlob AS DWORD
   hData = GlobalAlloc(%GHND, LEN(sText)+1)
   hGlob = GlobalLock(hData)
   POKE$ hGlob, sText + CHR$(0)
   GlobalUnlock hData
   ' ** Open the clipboard
   IF ISFALSE(OpenClipboard(%NULL)) THEN
      GlobalFree hData: EXIT FUNCTION
   END IF
   ' ** Paste the data into the clipboard
   EmptyClipboard
   FUNCTION = SetClipboardData(%CF_TEXT, hData)
   CloseClipboard
END FUNCTION

FUNCTION MakeFont(h AS LONG, xFont AS STRING, BYVAL ptSize AS LONG) AS LONG
  LOCAL yRes AS LONG, charHt AS LONG
  yRes  = GetDeviceCaps(h, %LOGPIXELSY)
  charHt = (PtSize * yRes) \ 72
  FUNCTION = CreateFont(-charHt, 0, 0, 0, %FW_NORMAL, 0, 0, 0, _
            %ANSI_CHARSET, %OUT_TT_PRECIS, %CLIP_DEFAULT_PRECIS, _
            %DEFAULT_QUALITY, %FF_DONTCARE, BYCOPY xFont)
END FUNCTION

FUNCTION Ifmt(BYVAL i AS LONG) AS STRING
   FUNCTION = LEFT$(TRIM$(STR$(i))+"    ", 4)
END FUNCTION

FUNCTION fmt(BYVAL a AS DOUBLE) AS STRING
   LOCAL s AS STRING, ss AS STRING, se AS STRING, n AS LONG, sa AS DOUBLE
   sa = SGN(a): a = ABS(a)
   IF a < 1.D-99 THEN
      s = "0.000": se = "+00": sa = 1
   ELSEIF a >= 1.D+99 THEN
      S = "1.000": se = "+99"
   ELSE
      s = TRIM$(STR$(a*1.D50, 4))
      n = VAL(RIGHT$(s, 2))-50
      IF n < 0 THEN ss = "-" ELSE ss = "+"
      se = TRIM$(STR$(ABS(n))): se = RIGHT$("0" + se, 2)
      s = LEFT$(s, LEN(s)-4)
      IF INSTR(s, ".") = 0 THEN s = s + "."
      s = LEFT$(s + "00000", 5)
   END IF
   IF sa < 0 THEN s = "-" + s ELSE s = " " + s
   FUNCTION = s + "E" + ss + se
END FUNCTION

sub printModel
   local hFontPrn, linesPerPg, nLines, i, k, n, pgNo as long
   local s as string
   s = "Print the file now?"
   n = MSGBOX(s, %MB_YESNO + %MB_ICONQUESTION, "Print File")
   IF n = %IDNO THEN EXIT SUB
   IF kStorData THEN storModelData
   k = %PD_ALLPAGES or %PD_NOPAGENUMS or %PD_NOSELECTION
   xprint attach choose using k
   xprint get attach to selectedPrinter
   FONT NEW "Courier New", 10 TO hFontPrn
   xprint set font hFontPrn
   xprint get lines to linesPerPg
   xprint
   for i = 1 to numLines
      IF i = 1 or nLines = linesPerPg THEN 'print title for new page
         nLines = 4: INCR pgNo
         s = space$(8) + nameOfFile + "  -  " + "Page" + STR$(pgNo)
         xprint s: xprint: xPrint
      END IF
      xprint space$(8) + modelData(i): incr nLines
      if (nLines = linesPerPg) and (i < numLines) then xprint formfeed
   next i
   xprint close
   'control send hDlg, %ID_Textbox, %EM_SETSEL, -1, 0 
end sub

sub printSoln(nOpt as long)
   'nOpt = 1  displacements
   'nOpt = 2  reactions
   'nOpt = 3  beam forces
   'nOpt = 4  quad stresses
   '----------------------------------------------------------------
   local i, j, k, m, n, hFontPrn, linesPerPg, nLines, pgNo as long
   local Ti(), Hdr(), sLine() AS STRING
   redim Ti(4), Hdr(4), sLine(4)
   TI(1) = "Deflections": TI(2) = "Reactions"
   TI(3) = "Beam Forces": TI(4) = "Quad Stresses"
   HDR(0) = "Grid      x Defl       y Defl       " + CHR$(248) + " Defl"
   HDR(1) = "Grid      x Ract       y Ract       " + CHR$(248) + " Ract"
   HDR(2) = "Beam   Grid     Axial        Shear        Moment"
   HDR(3) = "Quad   Grid      Sx           Sy           Sxy          Prin         vonM"
   HDR(4) = "Quad      Sx           Sy           Sxy          Prin         vonM"
   n = nGrids: prn = 1
   IF nOpt = 3 THEN n = nBeams
   IF nOpt = 4 THEN n = nQuads
   if len(selectedPrinter) then
      xprint attach selectedPrinter
   else
      k = %PD_ALLPAGES or %PD_NOPAGENUMS or %PD_NOSELECTION
      xprint attach choose using k
      xprint get attach to selectedPrinter
   end if
   FONT NEW "Courier New", 10 TO hFontPrn
   xprint set font hFontPrn
   xprint get lines to linesPerPg
   xprint 
   FOR i = 1 TO n
      IF i = 1 or nLines = linesPerPg THEN 'print title for new page
         nLines = 8: INCR pgNo
         xprint space$(8) + TI(nOpt)
         xprint space$(8) + nameOfFile + "  -  " + "Page" + STR$(pgNo)
         xprint: xPrint
         xprint space$(8) + HDR(nOpt - 1 + CINT(av))
         xprint: xPrint
      END IF
      m = getResultLines(i, nOpt, sLine())
      FOR j = 1 TO m
         xprint space$(8) + sLine(j)
      NEXT j
      incr nLines
      if nLines = linesPerPg and i < numLines then xprint formfeed
   NEXT i
   xprint close
end sub

SUB kQuad(iq AS LONG)
   LOCAL i AS LONG, j AS LONG, ii AS LONG, jj AS LONG
   LOCAL ngr AS LONG, m AS LONG, n AS LONG, k AS LONG
   LOCAL t AS DOUBLE, E AS DOUBLE, u AS DOUBLE, G AS DOUBLE
   LOCAL detJ AS DOUBLE, STFij AS DOUBLE
   DIM NDOF(8) AS LONG
   t = CQD(iq,3)
   E = CQD(iq,4)
   u = CQD(iq,5)
   G = CQD(iq,6)
   '
   '(sx,sy,sxy) = [DI] * (ex, ey, exy)
   'D11 = E/(1-u*u)
   'D12 = u*D11
   'D22 = D11
   'D33 = G
   'overwrite this sym [D] array with the upper triangular U (D = LU)
   '
   D(1) = SQR(E/(1-u*u))
   D(2) = u*D(1)
   D(3) = SQR(E)
   D(4) = SQR(G)
   FOR i = 1 TO 4
      ngr = XGR(NQD(iq,i))
      NDOF(2*i-1) = ABS(DOF(ngr,1))
      NDOF(2*i) = ABS(DOF(ngr,2))
      CQD(iq,i+3) = D(i)
   NEXT i
   'start gauss quadrature loop
   IF NQD(iq,4) = NQD(iq,3) THEN n = 6 ELSE n = 8
   FOR ii = 1 TO 2
   FOR jj = 1 TO 2
      quadJ ii, jj, iq, detJ
      IF detJ <= 0 THEN errMsg 21, iq, 0: EXIT SUB
      'compute 36 upper sym stiffness terms
      k = 7
      FOR i = 1 TO n
      FOR j = i TO n
         INCR k: STFij = 0
         FOR m = 1 TO 3
            STFij = STFij + B(m,i)*B(m,j)
         NEXT m
         STFij = STFij*detJ*t
         CQD(iq,k) = CQD(iq,k) + STFij
         kPut NDOF(i), NDOF(j), STFij
      NEXT j: NEXT i
   NEXT jj: NEXT ii
END SUB

SUB pQuad(i AS LONG)
   'compute P, PR due to edge forces and strains in undeformed quad i
   LOCAL j AS LONG, k AS LONG, m AS LONG, n AS LONG, n1 AS LONG, n2 AS LONG
   LOCAL ii AS LONG, jj AS LONG, node AS LONG, ith AS LONG
   LOCAL alfa AS DOUBLE, rho AS DOUBLE, t AS DOUBLE, w1 AS DOUBLE, w2 AS DOUBLE
   LOCAL x AS DOUBLE, y AS DOUBLE, a AS DOUBLE, b AS DOUBLE, s AS DOUBLE, c AS DOUBLE
   LOCAL dum1 AS DOUBLE, dum2 AS DOUBLE, detJ AS DOUBLE
   DIM PQ(8) AS DOUBLE, EPS0(3) AS DOUBLE, TEMP(4) AS DOUBLE
   alfa = CQD(i,1)
   rho = CQD(i,2)
   t = CQD(i,3)
   D(1) = CQD(i,4)
   D(2) = CQD(i,5)
   D(3) = CQD(i,6)
   D(4) = CQD(i,7)
   '------- edge forces
   IF NQD(i,4) = NQD(i,3) THEN n = 3 ELSE n = 4
   FOR k = 1 TO n
      w1 = FQD(i,k,1)
      w2 = FQD(i,k,2)
      IF w1 = 0 AND w2 = 0 THEN ITERATE
      FQD(i,k,1) = 0
      FQD(i,k,2) = 0
      n1 = XGR(NQD(i,k))
      IF k < n THEN n2 = XGR(NQD(i,k+1))
      IF k = n THEN n2 = XGR(NQD(i,1))
      IF n1 = n2 THEN ITERATE
      x = CORD(n2,1) - CORD(n1,1)
      y = CORD(n2,2) - CORD(n1,2)
      b = SQR(x*x + y*y)
      a = arcTan(y, x)
      s = SIN(a): c = COS(a)
      a = b*(2*w1+w2)/6
      PQ(2*k-1) = -a*s
      PQ(2*k) = a*c
      a = b*(2*w2+w1)/6
      IF k = n THEN
         PQ(1) = -a*s: PQ(2) = a*c
      ELSE
         PQ(2*k+1) = -a*s: PQ(2*k+2) = a*c
      END IF
   NEXT k
   '------- thermal strains
   ith = 0
   FOR j = 1 TO 4
      IF FQD(i,j,3) THEN ith = 1
   NEXT j
   IF ith THEN
      TEMP(1) = FQD(i,1,3)
      TEMP(2) = FQD(i,2,3)
      TEMP(3) = FQD(i,3,3)
      TEMP(4) = FQD(i,4,3)
      EPS0(3) = 0
      n = 0
      FOR ii = 1 TO 2
      FOR jj = 1 TO 2
         INCR n: EPS0(1) = 0
         FOR j = 1 TO 4
            dum1 = (1+XII(j)*GAUSS(ii))/4
            dum2 = (1+ETA(j)*GAUSS(jj))/4
            EPS0(1) = EPS0(1)+4*dum1*dum2*TEMP(j)
            a = 4*dum1*dum2*TEMP(j)
         NEXT j
         EPS0(1) = EPS0(1)*alfa
         EPS0(2) = EPS0(1)
         quadJ ii, jj, i, detJ
         EPS0(1) = D(1)*EPS0(1) + D(2)*EPS0(2)
         EPS0(2) = D(3)*EPS0(2)
         EPS0(3) = D(4)*EPS0(3)
         FQD(i,n,1) = -EPS0(1)
         FQD(i,n,2) = -EPS0(2)
         FQD(i,n,3) = -EPS0(3)
         FOR k = 1 TO 4
            node = XGR(NQD(i,k))
            FOR j = 1 TO 2
               m = 2*(k-1) + j
               a = B(1,m)*EPS0(1) + B(2,m)*EPS0(2) + B(3,m)*EPS0(3)
               PQ(m) = PQ(m) + a*detJ*t
            NEXT j
         NEXT k
      NEXT jj: NEXT ii
   END IF
   '------- body forces
   IF gx OR gy THEN
      TEMP(1) = gx
      TEMP(2) = gy
      FOR ii = 1 TO 2
      FOR jj = 1 TO 2
         quadJ ii, jj, i, detJ
         detJ = detJ*t
         FOR k = 1 TO 4
            dum1 = (1+XII(k)*GAUSS(ii))/4
            dum2 = (1+ETA(k)*GAUSS(jj))/4
            FOR j = 1 TO 2
               m = 2*(k-1) + j
               PQ(m) = PQ(m) + TEMP(j)*dum1*dum2*detJ
            NEXT j
         NEXT k
      NEXT jj: NEXT ii
   END IF
   FOR k = 1 TO 4
      node = XGR(NQD(i,k))
      s = 0: c = 1
      IF DOF(node,4) > 0 THEN
         a = CORD(node,3)
         s = SIN(a): c = COS(a)
      END IF
      FOR j = 1 TO 2
         m = DOF(node,j)
         IF j = 1 THEN a =  PQ(2*k-1)*c + PQ(2*k)*s
         IF j = 2 THEN a = -PQ(2*k-1)*s + PQ(2*k)*c
         IF m > 0 AND m <= neq THEN
            P(m) = P(m) + a
            PR(m) = PR(m) + a
         ELSEIF m THEN
            m = ABS(m): PR(m) = PR(m) - a
         END IF
      NEXT j
   NEXT k
END SUB

SUB QuadJ(ii AS LONG, jj AS LONG, iq AS LONG, detJ AS DOUBLE)
   LOCAL i AS LONG, j AS LONG, k AS LONG, n AS LONG, n1 AS LONG, ngr AS LONG
   LOCAL dum1 AS DOUBLE, dum2 AS DOUBLE, x1 AS DOUBLE, y1 AS DOUBLE
   LOCAL xgr AS DOUBLE, ygr AS DOUBLE
   DIM NXI(4) AS DOUBLE, NET(4) AS DOUBLE, JAC(2,2) AS DOUBLE
   FOR i = 1 TO 4
      dum1 = (1 + XII(i)*GAUSS(ii))/4
      dum2 = (1 + ETA(i)*GAUSS(jj))/4
      NXI(i) = XII(i)*dum2
      NET(i) = ETA(i)*dum1
   NEXT i
   '------- find Jacobian, its determinate, and its inverse
   n1 = XGR(NQD(iq,1))
   x1 = CORD(n1,1): y1 = CORD(n1,2)
   FOR i = 1 TO 4
      ngr = XGR(NQD(iq,i))
      xgr = CORD(ngr,1) - x1
      ygr = CORD(ngr,2) - y1
      JAC(1,1) = JAC(1,1) + NXI(i)*xgr
      JAC(1,2) = JAC(1,2) + NXI(i)*ygr
      JAC(2,1) = JAC(2,1) + NET(i)*xgr
      JAC(2,2) = JAC(2,2) + NET(i)*ygr
   NEXT i
   detJ = JAC(1,1)*JAC(2,2) - JAC(2,1)*JAC(1,2)
   dum1 = JAC(1,1)/detJ
   JAC(1,1) =  JAC(2,2)/detJ
   JAC(1,2) = -JAC(1,2)/detJ
   JAC(2,1) = -JAC(2,1)/detJ
   JAC(2,2) = dum1
   '------- form strain-displ matrix B
   IF NQD(iq,4) = NQD(iq,3) THEN n = 6 ELSE n = 8
   FOR k = 1 TO 4
      j = 2*k: i = j-1
      B(1,i) = JAC(1,1)*NXI(k) + JAC(1,2)*NET(k)
      B(1,j) = 0
      B(2,i) = 0
      B(2,j) = JAC(2,1)*NXI(k) + JAC(2,2)*NET(k)
      B(3,i) = B(2,j)
      B(3,j) = B(1,i)
   NEXT k
   IF n = 6 THEN
      FOR i = 1 TO 3
          B(i,5) = B(i,5) + B(i,7)
          B(i,6) = B(i,6) + B(i,8)
      NEXT i
   END IF
   'overwrite matrix B by U*B
   FOR j = 1 TO n
      B(1,j) = D(1)*B(1,j) + D(2)*B(2,j)
      B(2,j) = D(3)*B(2,j)
      B(3,j) = D(4)*B(3,j)
   NEXT j
END SUB

'sub plotModel()
'   local hGraphic, wi, ht, i, j as long
'   local xMin, xMax, yMin, yMax, x, x0, x1, x2, y, y0, y1, y2 as double
'   wi = 480: ht = 480
'   dialog get loc hDlg to i, j
'   GRAPHIC WINDOW NEW "Model Plot", i, j, wi, ht TO hGraphic
'   GRAPHIC ATTACH hGraphic, 0
'   IF kStorData THEN storModelData
'   if runPhase = 0 then
'      initialize
'      processModel
'   end if
'   xMin = 1.D99: xMax = -1.D99
'   yMin = 1.D99: yMax = -1.D99
'   FOR i = 1 TO numGrids
'      xMax = MAX(xMax, CORD(i,1))
'      xMin = MIN(xMin, CORD(i,1))
'      yMax = MAX(yMax, CORD(i,2))
'      yMin = MIN(yMin, CORD(i,2))
'   next i
'   x0 = (xMin + xMax)/2: x = xMax - xMin
'   y0 = (yMin + yMax)/2: y = yMax - yMin
'   xMin = x0 - .65*x: xMax = x0 + .65*x
'   yMin = y0 - .65*y: yMax = y0 + .65*y
'   if xMax - xMin then
'      x1 = xMin: x2 = xMax
'      y1 = y0 - (xMax-xMin)/2
'      y2 = y0 + (xMax-xMin)/2
'   else 'almost never used case of vert beam with xMax=xMin
'      y1 = yMin: y2 = yMax: 
'      x1 = x0 - (yMax-yMin)/2
'      x2 = x0 + (yMax-yMin)/2
'   end if
'   graphic scale (x1, y2) - (x2, y1)
'   redrawModel 0, 0, 0
'end sub

SUB plotModel()
   'runPhase = 0  plot model only
   '              otherwise, plot model with deformation
   '-----------------------------------------------------------------------
   LOCAL nStyle, wi, ht AS LONG
   LOCAL ti AS STRING
   redim defm(numGrids, 2)
   nStyle = %WS_SYSMENU OR %WS_THICKFRAME
   wi = 460: ht = 540: ti = "Finite Element Model Plot"
   DIALOG NEW pixels, 0, ti, , , wi, ht, nStyle TO hPlotDlg
   control add graphic, hPlotDlg, %ID_Graphic, "", 0, 0, wi, ht - 80
   CONTROL ADD LINE, hPlotDlg, %ID_Line, "", 0, 440, 520, 2
   if runPhase then
      CONTROL ADD SCROLLBAR, hPlotDlg, %ID_DefmScrl, "", 40, 480, 160, 16
      CONTROL ADD LABEL, hPlotDlg, %ID_Label1, "Deformation magnitude", 40, 500, 160, 20, %SS_CENTER
   end if
   CONTROL ADD checkbox, hPlotDlg, %ID_GridNum, "", 280, 480, 20, 20
   CONTROL ADD LABEL, hPlotDlg, %ID_Label2, "Grid Numbers", 240, 500, 120, 20, %SS_LEFT
   DIALOG SHOW MODELESS hPlotDlg CALL plotModelProc
END SUB

CALLBACK FUNCTION plotModelProc()
   local i, m, n, wi, ht as long
   local x1, x2, y1, y2, u, v, xlen, ylen as double
   LOCAL ps AS PAINTSTRUCT, pt AS POINTAPI
   static xppi, yppi as long
   STATIC uMax, d, x, y, x0, y0 AS DOUBLE
   static xMin, xMax, yMin, yMax AS DOUBLE
   DIM C(4,2) AS DOUBLE
   SELECT CASE CBMSG
   CASE %WM_INITDIALOG
      graphic attach cb.hndl, %ID_Graphic, redraw 
      graphic clear %white
      graphic color %Black, %white
      graphic get ppi to xppi, yppi
      if runPhase then
         si.cbSize = SIZEOF(si)
         si.fMask = %SIF_ALL
         si.nMin = 0: si.nMax = 20
         si.nPage = 2: si.nPos = 0
         CONTROL HANDLE CBHNDL, %ID_DefmScrl TO hScroll
         SetScrollInfo hScroll, %SB_CTL, si, 1
      else
         IF kStorData THEN storModelData
         initialize
         processModel
      end if
      xMin = 1.D99: xMax = -1.D99
      yMin = 1.D99: yMax = -1.D99
      uMax = -1.D99
      FOR i = 1 TO numGrids
         xMax = MAX(xMax, CORD(i,1))
         xMin = MIN(xMin, CORD(i,1))
         yMax = MAX(yMax, CORD(i,2))
         yMin = MIN(yMin, CORD(i,2))
         IF runPhase = 3 THEN 'get deformations
            getXYdefm i, u, v: DEFM(i, 1) = u: DEFM(i, 2) = v
            uMax = max(uMax, abs(u), abs(v))
         END IF
      NEXT i
      d = MAX(xMax-xMin, yMax-yMin)
      if d = 0 then exit function
      x0 = (xMin + xMax)/2: x = xMax - xMin
      y0 = (yMin + yMax)/2: y = yMax - yMin
      xMin = x0 - .65*x: xMax = x0 + .65*x
      yMin = y0 - .65*y: yMax = y0 + .65*y
      showGridNums = 0: scrlPos = 0
      CONTROL SET CHECK CBHNDL, %ID_GridNum, showGridNums
      IF runPhase < 3 THEN CONTROL DISABLE CBHNDL, %ID_DefmScrl
      DIALOG GET LOC CB.HNDL TO m, n
      DIALOG SET LOC CB.HNDL, m + 20, n + 20
      CONTROL SET FOCUS CBHNDL, %IDCANCEL
   CASE %WM_SIZE
      DIALOG GET client CB.HNDL TO wi, ht
      CONTROL SET LOC CB.HNDL, %ID_Line, 0, ht - 80
      CONTROL SET SIZE CB.HNDL, %ID_Line, wi, 2
      CONTROL SET LOC CB.HNDL, %ID_Label1, 40, ht - 40
      CONTROL SET LOC CB.HNDL, %ID_Label2, 250, ht - 40
      if runPhase then
         CONTROL SET LOC CB.HNDL, %ID_DefmScrl, 40, ht - 60
         CONTROL SET LOC CB.HNDL, %ID_GridNum, 280, ht - 60
      end if
      graphic set size wi, ht - 80
      xlen = wi/xppi: ylen = (ht-80)/yppi
      if xMax - xMin then
         x1 = xMin: x2 = xMax
         y1 = y0 - ylen/xlen*(xMax-xMin)/2
         y2 = y0 + ylen/xlen*(xMax-xMin)/2
      else 'almost never used case of vert beam with xMax=xMin
         y1 = yMin: y2 = yMax: 
         x1 = x0 - (yMax-yMin)/2
         x2 = x0 + (yMax-yMin)/2
      end if
      graphic scale (x1, y2) - (x2, y1)
      redrawModel scrlPos, uMax, d
   CASE %WM_COMMAND
      IF CBCTL = %ID_GridNum THEN
         IF showGridNums THEN showGridNums = 0 ELSE showGridNums = 1
         CONTROL SET CHECK CBHNDL, CBCTL, showGridNums
         redrawModel scrlPos, uMax, d
      ELSEIF CBCTL = %IDCANCEL THEN
         DIALOG END CBHNDL
      END IF
   case %WM_DESTROY 
      control set focus hDlg, %ID_Textbox  
   CASE %WM_HSCROLL
      SELECT CASE LOWRD(CBWPARAM)
         CASE %SB_LINEDOWN
            if scrlPos = 20 then exit function
            INCR scrlPos: IF scrlPos > 20 THEN scrlPos = 20
         CASE %SB_LINEUP
            if scrlPos = 0 then exit function
            DECR scrlPos: IF scrlPos < 0 THEN scrlPos = 0
         CASE %SB_THUMBPOSITION
            scrlPos = HIWRD(CBWPARAM)
         CASE %SB_THUMBTRACK
            scrlPos = HIWRD(CBWPARAM)
      END SELECT
      si.fMask = %SIF_POS
      si.npos = scrlPos
      SetScrollInfo hScroll, %SB_CTL, si, 1
      redrawModel scrlPos, uMax, d
   END SELECT
END FUNCTION

sub redrawModel(scrlPos as long, uMax as double, d as double)
   local i, n1, n2, n3, n4 as long
   local x, y, x1, y1, x2, y2, x3, y3, x4, y4, g as double
   if scrlPos then g = .10*d*scrlPos/20
   graphic clear %white
   IF showGridNums THEN  'show grids
      for i = 1 to numGrids
         x = CORD(i, 1): y = CORD(i, 2)
         graphic set pos (x, y)
         graphic print str$(i)
      next i
   END IF
   for i = 1 to numBeams  'show beams
      n1 = XGR(NBM(i,1)): n2 = XGR(NBM(i,2))
      x1 = CORD(n1, 1): y1 = CORD(n1, 2)
      x2 = CORD(n2, 1): y2 = CORD(n2, 2)
      graphic line (x1, y1) - (x2, y2)
      IF uMax > 0 THEN
         x1 = x1 + g*DEFM(n1, 1)/uMax: y1 = y1 + g*DEFM(n1, 2)/uMax
         x2 = x2 + g*DEFM(n2, 1)/uMax: y2 = y2 + g*DEFM(n2, 2)/uMax
         graphic line (x1, y1) - (x2, y2)
      END IF
   next i
   FOR i = 1 TO numQuads 'show quads
      n1 = XGR(NQD(i,1)): n2 = XGR(NQD(i,2))
      n3 = XGR(NQD(i,3)): n4 = XGR(NQD(i,4))
      x1 = CORD(n1, 1): y1 = CORD(n1, 2)
      x2 = CORD(n2, 1): y2 = CORD(n2, 2)
      x3 = CORD(n3, 1): y3 = CORD(n3, 2)
      x4 = CORD(n4, 1): y4 = CORD(n4, 2)
      graphic line (x1, y1) - (x2, y2)
      graphic line          - (x3, y3)
      graphic line          - (x4, y4)
      graphic line          - (x1, y1)
      IF uMax > 0 THEN
         x1 = x1 + g*DEFM(n1, 1)/uMax: y1 = y1 + g*DEFM(n1, 2)/uMax
         x2 = x2 + g*DEFM(n2, 1)/uMax: y2 = y2 + g*DEFM(n2, 2)/uMax
         x3 = x3 + g*DEFM(n3, 1)/uMax: y3 = y3 + g*DEFM(n3, 2)/uMax
         x4 = x4 + g*DEFM(n4, 1)/uMax: y4 = y4 + g*DEFM(n4, 2)/uMax
         graphic line (x1, y1) - (x2, y2)
         graphic line          - (x3, y3)
         graphic line          - (x4, y4)
         graphic line          - (x1, y1)
      END IF
   next i
   graphic redraw
end sub

SUB getXYdefm(i AS LONG, x AS DOUBLE, y AS DOUBLE)
   LOCAL m AS LONG, n AS LONG, a AS DOUBLE, c AS DOUBLE, s AS DOUBLE, z AS DOUBLE
   a = CORD(i,3): x = 0: y = 0
   m = ABS(DOF(i,1)): n = ABS(DOF(i,2))
   IF m AND m <= neq THEN x = P(m)
   IF n AND n <= neq THEN y = P(n)
   IF a THEN
      c = COS(a): s = SIN(a): z = x
      x = x*c - y*s: y = z*s + y*c
   END IF
END SUB

SUB rbdofs
   'This routine checks whether rigid body dofs are restrained
   LOCAL i AS LONG, j AS LONG, k AS LONG, kp AS LONG, kr AS LONG
   LOCAL nSpace AS LONG, s AS STRING, a AS DOUBLE
   DIM R(3) AS DOUBLE, V(2, 3) AS DOUBLE
   'nSpace = 0... determine dim of P-space
   'nSpace = 1... determine dim of R-space
   DO
      FOR i = 1 TO numGrids
         IF DOF(i,4) > 0 THEN a = CORD(i,3) ELSE a = 0
         FOR j = 1 TO 3
            IF nSpace = 0 AND DOF(i,j) <= 0 AND DOF(i,j) > neq THEN ITERATE
            IF nSpace = 1 AND DOF(i,j) >= 0 AND DOF(i,j) <= neq THEN ITERATE
            IF j = 1 THEN
               R(1) = COS(a)
               R(2) = SIN(a)
               R(3) = CORD(i,1)*R(1) - CORD(i,2)*R(1)
            ELSEIF j = 2 THEN
               R(1) = -SIN(a)
               R(2) = COS(a)
               R(3) = CORD(i,1)*R(2) - CORD(i,2)*R(1)
            ELSE
               R(1) = 0
               R(2) = 0
               R(3) = 1
            END IF
            orth k, R(), V()
            IF k >= 3 THEN EXIT, EXIT
         NEXT j
      NEXT i
      IF nSpace = 0 THEN kp = k ELSE kr = k
      IF kr >= 3 THEN EXIT SUB
      INCR nSpace: k = 0
   LOOP UNTIL nSpace > 1
   k = kp - kr
   s = " rigid body dofs exist"
   IF k = 1 THEN MID$(s, 16) = " exists"
   sSolve = sSolve + $CRLF + TRIM$(STR$(k)) + s
   CONTROL SET TEXT hModelDlg, %ID_Output, sSolve
END SUB

SUB orth(k AS LONG, R() AS DOUBLE, V() AS DOUBLE)
   LOCAL c1 AS DOUBLE, c2 AS DOUBLE, rr AS DOUBLE
   c1 = R(1)*V(1,1)+R(2)*V(1,2)+R(3)*V(1,3)
   IF k = 1 THEN
      R(1) = R(1)-c1*V(1,1)
      R(1) = R(1)-c1*V(1,2)
      R(1) = R(1)-c1*V(1,3)
   ELSEIF k = 2 THEN
      c2 = R(1)*V(2,1)+R(2)*V(2,2)+R(3)*V(2,3)
      R(1) = R(1)-c1*V(1,1)-c2*V(2,1)
      R(2) = R(2)-c1*V(1,2)-c2*V(2,2)
      R(3) = R(3)-c1*V(1,3)-c2*V(2,3)
   END IF
   rr = SQR(R(1)*R(1)+R(2)*R(2)+R(3)*R(3))
   IF rr < eTol THEN EXIT SUB
   INCR k: IF k >= 3 THEN EXIT SUB
   V(k,1) = R(1)/RR
   V(k,2) = R(2)/RR
   V(k,3) = R(3)/RR
END SUB

FUNCTION arcTan(y AS DOUBLE, x AS DOUBLE) AS DOUBLE
   LOCAL e AS DOUBLE
   e = 1.D-100 * ABS(y)
   IF ABS(x) < e AND y > 0 THEN
      FUNCTION = 2*ATN(1)
   ELSEIF ABS(x) < e AND y < 0 THEN
      FUNCTION = -2*ATN(1)
   ELSEIF x > 0 THEN
      FUNCTION = ATN(y/x)
   ELSE
      FUNCTION = 4*ATN(1) + ATN(y/x)
   END IF
END FUNCTION

SUB errMsg(n AS LONG, i AS LONG, j AS LONG)
   LOCAL s AS STRING
   SELECT CASE n
   CASE 1
      s = "... Grid equate" + STR$(i) + " not found"
   CASE 2
      s = "... Polar center grid" + STR$(i) + " not found"
   CASE 3
      s = "... Polar center grid" + STR$(i) + " not cartesian"
   CASE 4
      s = "... Grid number" + STR$(i) + " not found"
   CASE 5
      s = "... Prop" + STR$(i) + " not found"
   CASE 6
      s = "... Matl" + STR$(i) + " not found"
   CASE 7
      s = "... Grid" + STR$(i) + " a duplicate"
   CASE 8
      s = "... Bad record... check syntax"
   CASE 9
      s = "Grid" + STR$(i) + " of beam" + STR$(j) + " not found"
   CASE 10
      s = "Grid" + STR$(i) + " of quad" + STR$(j) + " not found"
   CASE 11
      s = "PROP missing from beam" + STR$(i)
   CASE 12
      s = "MATL missing from beam" + STR$(i)
   CASE 13
      s = "PROP missing from quad" + STR$(i)
   CASE 14
      s = "MATL missing from quad" + STR$(i)
   CASE 15
      s = "No PROP record found"
   CASE 16
      s = "No MATL record found"
   CASE 17
      IF i THEN s = " for record" + STR$(i)
      s = "Input order is wrong" + s
   CASE 18
      s = "Must re-sequence all grids consecutively"
   CASE 19
      s = "Must include constraints (RACT or SPRG)"
   CASE 20
      s = "stiff elem no." + STR$(i) + " Exceeds storage space of 16000"
   CASE 21
      s = "Quad" + STR$(i) + " grids not counter-clockwise order"
   CASE 22
      s = "Number of subcases exceeds maximum of" + STR$(i)
   CASE 23
      s = "No grids found (GRID)"
   CASE 24
      s = "No elements found (BEAM, QUAD)"
   CASE 25
      s = "No properties found (PROP)"
   CASE 26
      s = "No materials found (MATL)"
   CASE 27
      s = "No restraints found (RACT, SPRG)"
   CASE 28
      s = "ENDMODEL not found"
   END SELECT
   IF n <= 8 THEN sErr = sErr + modelData(j) + $CRLF
   sErr = sErr + s + $CRLF
END SUB

SUB createFolder(folder AS STRING)
   LOCAL i, n AS LONG
   LOCAL f, s AS STRING
   n = PARSECOUNT(folder, "\")
   FOR i = 1 TO n
      f = PARSE$(folder, "\", i)
      IF LEN(f) THEN
         s = s + f + "\"
         IF ISFOLDER(s) = 0 THEN MKDIR s
      END IF
   NEXT i
END SUB

FUNCTION SpecialFolder(pidl AS DWORD) AS STRING
' by Wayne Diamond 12-03-01
' http://www.powerbasic.com/support/forums/Forum7/HTML/001233.html
'----------------------------------------------------------------------
   LOCAL TmpAsciiz AS ASCIIZ * %MAX_PATH
   CoInitialize BYVAL 0
   IF ISFALSE(SHGetSpecialFolderLocation(BYVAL %HWND_DESKTOP, BYVAL pidl, BYVAL VARPTR(pidl))) THEN
      SHGetPathFromIDList BYVAL pidl, TmpAsciiz
      CoTaskMemFree BYVAL pidl
   END IF
   CoUninitialize
   FUNCTION = TmpAsciiz
END FUNCTION

'-----------------------------------------------------------------------
'Show About
'-----------------------------------------------------------------------
SUB showAbout
   LOCAL hAbout AS LONG, s AS STRING
   DIALOG NEW hDlg,"About FE2D",,, 240, 160, %WS_SYSMENU TO hAbout
   CONTROL ADD LABEL, hAbout, 9901, "2D Finite Elements", 50, 10, 125, 20
   CONTROL ADD LABEL, hAbout, 9902, " for Windows", 155, 13, 70, 10
   s = "Version " + $verNo + " - Free distribution" + $CRLF
   s = s + "by Charles G. Dietz" + $CRLF + $CRLF
   CONTROL ADD LABEL, hAbout, 9903, s, 50, 40, 180, 30
   s = "chasdietz@verizon.net"
   CONTROL ADD LABEL, hAbout, 9904, s, 60, 80, 140, 12, %SS_NOPREFIX OR %SS_NOTIFY
   s = "http://www.cgdsoftware.com"
   CONTROL ADD LABEL, hAbout, 9905, s, 60, 95, 140, 12, %SS_NOPREFIX OR %SS_NOTIFY
   CONTROL ADD IMAGE, hAbout, -1, "FE2D", 10, 10, 0, 0
   DIALOG SHOW MODAL hAbout, CALL showAboutProc
END SUB

CALLBACK FUNCTION showAboutProc()
   LOCAL hFont AS LONG
   LOCAL url, email AS ASCIIZ*64
   SELECT CASE CB.MSG
   CASE %WM_PAINT
      FONT NEW "MS Sans Serif", 14 TO hFont
      CONTROL SET COLOR CB.HNDL, 9901, %RED, -1
      CONTROL SET FONT CB.HNDL, 9901, hFont
      FONT NEW "MS Sans Serif", 10, 2 TO hFont
      CONTROL SET FONT CB.HNDL, 9902, hFont
      FONT NEW "MS Sans Serif", 10 TO hFont
      CONTROL SET FONT CB.HNDL, 9903, hFont
      FONT NEW "MS Sans Serif", 10, 4 TO hFont
      CONTROL SET COLOR CB.HNDL, 9904, %BLUE, -1
      CONTROL SET FONT CB.HNDL, 9904, hFont
      FONT NEW "MS Sans Serif", 10, 4 TO hFont
      CONTROL SET COLOR CB.HNDL, 9905, %BLUE, -1
      CONTROL SET FONT CB.HNDL, 9905, hFont
      FONT END hFont
   CASE %WM_SETCURSOR  'Change cursor to hand when hovering over label
      IF GetDlgCtrlId(CBWPARAM) >= 9904 THEN
         SetCursor LoadCursor(%NULL, BYVAL %IDC_HAND)
         SetWindowLong CB.HNDL, %DWL_MSGRESULT, 1: FUNCTION = 1
      END IF
   CASE %WM_COMMAND
      IF CB.CTL = %IDOK OR CB.CTL = %IDCANCEL THEN
         DIALOG END CB.HNDL
      ELSEIF CB.CTL = 9904 THEN
         email = "chasdietz@verizon.net"
         ShellExecute(0, "open", "mailto:" + email + "?", "", "", %SW_SHOW)
      ELSEIF CB.CTL = 9905 THEN
         url = "http://www.cgdsoftware.com"
         ShellExecute(BYVAL %NULL, "open", url, BYVAL %NULL, BYVAL %NULL,%SW_SHOWMAXIMIZED)
      END IF
   END SELECT
END FUNCTION
